rem *****************************************************************
rem The following variables need to be modified to something appropriate 
rem for the HR Vision installation
rem ******************************************************************

rem the user= and pw= used to login to the warehouse
set user=sysadm
set pw=sysadm

rem wh= specifies the warehouse key to update
set wh=p000001

set productdrive=c:

rem product= specifies the physical directory path of HR Vision
set product=%productdrive%\Program Files\SAS Institute\HR Vision\3.1

rem vproduct= specifies the URL to HR Vision
set vproduct=http://localhost/Hrv3.1/

rem The various log and lst files should be routed to a directory and secured from unauthorized access
rem By default, these log files will be placed in the %product%\WEB-INF directory.
set hrvbuildlog=%product%\hrvbuild.log
set hrvbuildout=%product%\hrvbuild.lst
set hrvregreposlog=%product%\hrvregrepos.log
set hrvlog=%product%\hrv.log
set hrvrrlog=%product%\hrvrr.log

rem *********************************************************************
rem There should be no need to edit the section below
rem *********************************************************************
set webinf=%product%\WEB-INF
set lib=%webinf%\lib

rem set CLASSPATH=".;%webinf%/classes;%lib%/hrv.jar;%lib%/parser.jar;%lib%/webAF.jar;%lib%/remobj.jar;%lib%/netutil.jar;%lib%/iomdriver.jar;%lib%/brgorb.jar;%lib%/iomprx.jar;%lib%/connect.jar;%lib%/webAFServerPages.jar;%lib%/mail.jar;%product%/Appl/servlet.jar"

set CLASSPATH=".;%webinf%/classes"

%productdrive%
cd %lib%

Java -Djava.ext.dirs="%lib%;%product%/appl/" com.sas.hrv.BatchRefresh2 -u %user% -pw %pw% -wh %wh% -log "%hrvbuildlog%" -out "%hrvbuildout%" -prod "%product%" -vprod %vproduct% > "%hrvlog%"
Java -Djava.ext.dirs="%lib%;%product%/appl/" com.sas.hrv.RegRepos -u %user% -pw %pw% -wh %wh% -log "%hrvregreposlog%" -prod "%product%" -vprod %vproduct% > "%hrvrrlog%"