rem *****************************************************************
rem The following variables need to be modified to something appropriate 
rem for the HR Vision installation
rem                              
rem Please note that for this program to run successfully you must verify
rem that there are no lingering SAS sessions running on the system.
rem ******************************************************************

rem the user= and pw= used to login to the warehouse
set user=sysadm
set pw=sysadm

rem wh= specifies the warehouse key to update
set wh=p000001

set productdrive=c:

rem product= specifies the physical directory path of HR Vision
set product=%productdrive%\Program Files\SAS Institute\HR Vision\3.1

rem vproduct= specifies the URL to HR Vision
set vproduct=http://localhost/Hrv3.1/

rem The various log files should be routed to a directory and secured from unauthorized access
set hrvregreposlog=%product%\hrvregrepos.log
set hrvrrlog=%product%\hrvrr.log

rem *********************************************************************
rem There should be no need to edit the section below
rem *********************************************************************
set webinf=%product%\WEB-INF
set lib=%webinf%\lib

set CLASSPATH=.;%webinf%/classes;%lib%/hrv.jar;%lib%/parser.jar;%lib%/webAF.jar;%lib%/remobj.jar;%lib%/netutil.jar;%lib%/iomdriver.jar;%lib%/brgorb.jar;%lib%/iomprx.jar;%lib%/connect.jar;%lib%/webAFServerPages.jar;%lib%/mail.jar;%product%/Appl/servlet.jar
%productdrive%
cd %lib%

Java com.sas.hrv.RegRepos -u %user% -pw %pw% -wh %wh% -log "%hrvregreposlog%" -prod "%product%" -vprod %vproduct% > "%hrvrrlog%"