<%@page import="java.io.*,java.util.*,com.sas.sasserver.dataset.*,com.sas.servlet.util.*" %>
<%@page import="com.sas.hrv.*" %>

<%
        // get the information necessary to log the user in.
        String curWH = request.getParameter("curWH");
        String user = request.getParameter("user");
        String pw = request.getParameter("pw");
        String table = request.getParameter("table");
        String loc = request.getParameter("loc");
        String labels = request.getParameter("labels");
        if (labels == null)
                labels = "";
        String column;
        int location=1;
        String delim = ":=";
        boolean isLogged = false;

                        // need to get a dataset object to the source table to verify column existence.

//        ConnectionInterface cI = ConnectionInterface.getInstance(session, false);


        // get an instance of HrvInfo.
        HrvInfo hrvi = HrvInfo.getInstance(application, request, response, out);

        if (curWH == null || user == null || table == null)
                throw new Exception("ERROR: curWH is " + curWH + ", user is " + user + ", table is " + table);
        try {
                // log the user in.
                if (!hrvi.isLoggedIn(session))
                        hrvi.dualLogIn(session, curWH, user, pw);
                if (!hrvi.isLoggedIn(session)) {
                        throw new Exception("Login Failed.");
                }
                else
                        out.println("<br>Logged into warehouse " + curWH + " as " + user);

                // get necessary instances.
                isLogged = true;
                UserBean hrvUser = new UserBean(session);
                out.println("<br>got UserBean");
                SecuritySubsetBean subset = new SecuritySubsetBean(session);
                out.println("<br>got SecuritySubsetBean");
                TableBean hrvTable = new TableBean(session);
                out.println("<br>got TableBean");
                MakeView mV = new MakeView(session, false);
                out.println("<br>got mV");
                VisMsg vM = VisMsg.getInstance(session);
                out.println("<br>got vM");

                // decide on the table location
                // sysadm is alway public
                if (hrvi.isUserAdmin(session)) {
                        location = ItemBean.PUBLIC_LOC;
                        loc = "PUBDATA";
                }

                // if no location is passed in, then set location based on where it exists, checking private first
                else if ( loc == null || loc.equals("" )) {
                        if ( mV.exists( table, "PRIVATE" )) {
                                location = ItemBean.PRIVATE_LOC;
                                loc = "PRVDATA";
                        }
                        else if ( mV.exists( table, "PUBLIC" )) {
                                location = ItemBean.PUBLIC_LOC;
                                loc = "PUBDATA";
                        }
                        else throw new Exception("ERROR: " + table + " doesn't exist.");
                }

                else if (loc.equalsIgnoreCase("dwdata")) {
                        // not sysadm and is set to dwdata, so do a look through.
                        try {
                                hrvTable.setMetaLocation(hrvTable.PRIVATE_LOC);
                                hrvTable.setMetaKey(table);
                                String temp = hrvTable.getAttributeValue("desc");
                                location = hrvTable.PRIVATE_LOC;
                        }
                        catch(Exception e) {
                                location = hrvTable.PUBLIC_LOC;
                        }
                }

                // explicitly set to public
                else if (loc.equalsIgnoreCase("public") ||
                                        loc.equals(ItemBean.PUBLIC_LOC_STRING) ||
                                        loc.equalsIgnoreCase(ItemBean.PUBLIC_DATA_LIBREF)) {
                        location = ItemBean.PUBLIC_LOC;
                        loc = "PUBDATA";
                }

                // explicitly set to private
                else if (loc.equalsIgnoreCase("private") ||
                                        loc.equals(ItemBean.PRIVATE_LOC_STRING) ||
                                        loc.equalsIgnoreCase(ItemBean.PRIVATE_DATA_LIBREF)) {
                        location = ItemBean.PRIVATE_LOC;
                        loc = "PRVDATA";
                }

                // if set to something besides public, private or dwdata, then default to public
                else {
                        location = ItemBean.PUBLIC_LOC;
                        loc = "PUBDATA";
                }
                out.println("<br>set location to " + location + ", " + loc);

                // now test for the existence of the table
                if (!mV.exists( table, loc)) throw new Exception("ERROR: " + table + " doesn't exist.");

                out.println("<br>Beginning information delivery for table " + table + "...<br>");

                // generate some messages.
                String msgStr = vM.getSentence("DataSetNotFoundWarn");
                out.println("msgstr" + delim + msgStr);
                out.println("<br>");
                String secMsgStr = vM.getSentence("SecSubsetNotApplied");
                out.println("secmsgstr" + delim + secMsgStr);
                out.println("<br>");

                // set the user.
                hrvUser.setUser(hrvi.getUser(session));

                // get the security subset key value for the current user.
                String sub = hrvUser.getAttributeValue("subset");
                String secSubset;
                String masterSecTable = "empmast";

                // set security subset to blank when the user has no sec subset.
                if (sub == null || sub.equals(""))
                        secSubset = "";
                else {
                        // user has a sec subset, so get it.
                        MakeView mv = new MakeView(session, false);
                        secSubset = mv.getSecSubset();
                        masterSecTable = mv.getMasterSecTable();
                }

                // set location.
                hrvTable.setMetaLocation(location);

                // set key.
                hrvTable.setMetaKey(table);

                // determine if security is applied or not.
                String applysec = hrvTable.getAttributeValue("applysec");
                if (applysec != null && applysec.equalsIgnoreCase("N"))
                        secSubset = "";
                // put out the security subset information for the sas data set to read.
                out.println("secsubset" + delim + secSubset);
                out.println("<br>");
                out.println("masterSecTable" + delim + masterSecTable);
                out.println("<br>");

                // generate the data set name, use the key if there is no data set name.
                String dsName = hrvTable.getAttributeValue("datasetname");
                if (dsName == null || dsName.equals(""))
                        dsName = table;
                out.println("dsname" + delim + dsName);
                out.println("<br>");

                // if this is a tbltype of SAS, then put out the appropriate libname statement.
                String tbltype = hrvTable.getAttributeValue("tbltype");
                String directory, libStmt="";
                if (tbltype != null && tbltype.equalsIgnoreCase("SAS")) {
                    String program = hrvTable.getAttributeValue("program");
                    if (program == null)
                    program = "";
                    // code from cahadd to get directory value.
                    int slashIndex = program.lastIndexOf ("/");
                    if (slashIndex < 0)
                    slashIndex = program.lastIndexOf ("\\");
                    directory = program.substring (0, slashIndex+1);

                    // now generate the actual libname statement.
                    libStmt = "libname " + table + " '" + directory + "';";
                }
                
                // now see if the masterSecTable is a tbltype of SAS.  If it is, then
                // generate the apropriate libname statemtent for it and tack it on to
                // the libStmt value that already exists.
                TableBean masterHrvTable = new TableBean(session);
                masterHrvTable.setMetaLocation(hrvTable.getMetaLocation());
                masterHrvTable.setMetaKey(masterSecTable);
                String masterDsName = masterHrvTable.getAttributeValue("datasetname");
                if (masterDsName == null || masterDsName.equals(""))
                    masterDsName = masterSecTable;
                String masterTbltype = masterHrvTable.getAttributeValue("tbltype");
                
                String masterDirectory, masterLibStmt="";
                if (masterTbltype != null && masterTbltype.equalsIgnoreCase("SAS")) { 
                    String masterProgram = masterHrvTable.getAttributeValue("program");
                    if (masterProgram == null)
                        masterProgram = "";
                    // code from cahadd to get directory value.
                    int masterSlashIndex = masterProgram.lastIndexOf ("/");
                    if (masterSlashIndex < 0)
                    masterSlashIndex = masterProgram.lastIndexOf ("\\");
                    masterDirectory = masterProgram.substring (0, masterSlashIndex+1);
                
                    // now generate the actual libname statement.
                    masterLibStmt = " libname " + masterSecTable + " '" + masterDirectory + "';";
                }
                
                

                // now put it out to be read by the sas code.
                out.println("initcode" + delim + libStmt + masterLibStmt);

                // get the password required for the sas job.
                out.println("<BR>");
                out.println("dspwd" + delim + java.net.URLEncoder.encode(hrvUser.encryptDsPw(mV.getPwd())));
                out.println("<br>");

                // send back the location in case it wasn't sent in
                out.println("location" + delim + loc);
                out.println("<br>");

                // pick out the master column.
                String keyVar="";
                hrvTable.resetColumnList();
                hrvTable.setColumnFilter("key = \"M\"");
                if (hrvTable.nextColumn())
                        keyVar = hrvTable.getCurrentColumn();
                out.println("keyvar" + delim + keyVar);
                out.println("<br>");

                // reset the column info.
                hrvTable.setColumnFilter("");
                hrvTable.resetColumnList();

                // get the column information from the table.
                int ncols = 0;
                String colStr = "";

                // submit libname for views to work.
//                if (!libStmt.equals("")) {
//                        StringBuffer sb = new StringBuffer();
//                        sb.append(libStmt);
//                        cI.submit(sb.toString());
//                }

                // put the list of metadata columns into a namedlist so they can be orderred.
                String thisColumn, orderNum;
                NamedList columnNodeList = hrvTable.getColumnNodes();
                NamedList columnSortList = new NamedList();
                Vector lastCols = new Vector();
                for (int i = 0; i < columnNodeList.size(); i++) {
                        thisColumn = columnNodeList.getName(i);
                        orderNum = hrvTable.getColumnAttributeValue("order",columnNodeList.getValue(i));
                        if (orderNum != null && !orderNum.equals("") && !orderNum.equals("."))
                                columnSortList.add(thisColumn, orderNum);
                        else
                                lastCols.add(thisColumn);
                }
                // now sort by the order.
                columnSortList.sortByAscendingValue(true);
                // now put the columns with no order specified at the end.
                for (int i=lastCols.size()-1; i>=0; i--)
                        columnSortList.add((String)lastCols.get(i), (String)"");

//                DataSetInterface ds =(DataSetInterface)Util.newInstance(cI.getRocf(),cI.getCon(),DataSetInterface.class);
                try {
//                        ds.setDataSet(loc + "." + dsName + "(pw=\"" + mV.getPwd() + "\")");
                        for (int i=0; i<columnSortList.size(); i++){
                                // get column id.
                                String colName = (String)columnSortList.getName(i);
                               // column = mV.generateColumn(colName, columnNodeList.getValue(colName), hrvTable, ds, false, labels);
                                column = mV.generateColumn(colName, columnNodeList.getValue(colName), hrvTable, null, false, labels);
                                if (column.startsWith(",")) column = column.substring(1);
                                if (!column.equals("")) {
                                        ncols++;
                                        colStr += "\ncol" + ncols + delim + column + "\n<br>";
                                }
                        }
//                        ds.close();
                        out.println("ncols" + delim + ncols);
                        out.println("<br>");
                        out.println(colStr);
                }
                catch (IllegalArgumentException e) {
                        // can't open the data set, so close it.
                        System.out.println("ERROR: Unable to open data set: " + loc + "." + table + " to check columns.");
//                        if (ds != null)
//                                ds.close();
                }

                // we're done
                hrvi.logOff(session);
                out.println("<br>Finished.  Logging off...");
        }
        catch (Exception e) {
                out.println("<BR><B>e: </B>" + e);
                if (isLogged)
                        hrvi.logOff(session);
        }
%>