<%-- Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513 --%>
<%@ page errorPage="../Query/QueryErr.jsp" %>
<%@ page import="java.io.*,java.util.*" %>
<%@ page import="java.text.ParseException, java.text.SimpleDateFormat" %>
<%@ page import="com.sas.query.*" %>
<%@ page import="com.sas.query.app.*" %>
<%@ page import="com.sas.query.datasources.*" %>
<%@ page import="com.sas.query.models.*" %>
<%@ page import="com.sas.query.models.Expression" %>
<%@ page import="com.sas.query.parser.*" %>
<%@ page import="com.sas.query.visuals.*" %>
<%@ page import="com.sas.hrv.*" %>
<%@ page import="com.sas.rmi.Connection" %>
<%@ page import="com.sas.servlet.beans.*" %>
<%@ page import="com.sas.servlet.beans.html.*" %>
<%@ page import="com.sas.collection.StringCollection" %>
<%@ include file="../Jsp/HRVLoginInclude.jsp" %>
<%@ include file="../Query/QueryInclude.jsp" %>
<%!
   static StringCollection andOrModel = new StringCollection();
   static {
      andOrModel.add("AND");
      andOrModel.add("OR");
   }

   Hashtable m_formOptions = null;

   static FunctionList m_validConditionals = null;
   static FunctionList m_functionList = null;

   public static final int MODE_DEFAULT = 0;
   public static final int MODE_FULL = 0;
   public static final int MODE_WHERE = 1;
   boolean isAlias = false;
   //###Added by sinsat on 06SEP2004 - start
   int intInfo	= 0;
   int operatorIndex = 0;
   //###Added by sinsat on 06SEP2004 - end

   // Fix for DEFECT 0220655 - By sinakv
   // A unique string that will substitute a blank at the start of the query text
   // so that it does not get trimmed off.
   private static final String blankSubstitute = "^~(";

%>
<%

   int mode = MODE_FULL;
   if ("wherecb".equals(request.getAttribute("topic")))
      mode = MODE_WHERE;

   boolean hasError = false;    //Error flag for the page
   request.setAttribute("error.message", "");
   boolean fromModel = false;

    // establish the queryObs variable.
   String queryObs = request.getParameter("queryObs");
   if (queryObs == null && m_query.getPersistedItemList().size() > 0) {
        TableList tablesInModel = m_query.getTables();  //the list of tables in the model
        //look at the first table in the model.
        com.sas.query.models.Table table = tablesInModel.elementAt(0);
        HRVDataSourceTable hrvDST = (HRVDataSourceTable)table.getDataSourceTable();
        queryObs = hrvDST.getQueryObs();
    }
    if (queryObs == null)
    queryObs = "";

   //This variable is for request parameter propagation
   HashMap riders = new HashMap();
   riders.put("sessionkey", m_sessionKey);
   //need to propagate several HRV parameters
   riders.put("explorerType", request.getParameter("explorerType"));
   riders.put("actualType", request.getParameter("actualType"));
   riders.put("window", request.getParameter("window"));
   riders.put("topic", request.getParameter("topic"));

   TableList tablesInModel = m_query.getTables();   //the list of tables in the model
    //step through the tables in the model.
    for (int i=0; i<tablesInModel.size(); i++) {
        com.sas.query.models.Table table = tablesInModel.elementAt(i);
        HRVDataSourceTable hrvDST = (HRVDataSourceTable)table.getDataSourceTable();
        hrvDST.setQueryObs(queryObs);
    }

   //Get the resource bundle for this request
   VisMsg bundle = (VisMsg)request.getAttribute( "resources" );

   //get the action value (if any)
   String action = request.getParameter("intAction");
   //Get next step to go to (if any)
   String stepToGoto = null;
   if (action != null) {
      if (action.startsWith("goto.")) {
         stepToGoto = action.substring(5);
      } else if (mode == MODE_WHERE) {
         if ("ok".equals(action)) {
        //user is finished with filter - send to return URL w/ new where
        // clause
        stepToGoto = "whereOK";
     } else if ("cancel".equals(action)) {
        //user has aborted changes to filter - send to return URL w/ old
        // where clause
        stepToGoto = "whereCancel";
     }
      }
      //stepToGoto now holds (hopefully) a topic whose URL is defined in the
      //  resource bundle or blank if staying here
   }

//////////////////////////////////////////////////////////////////////
//  Process form data and update the query model if possible
//////////////////////////////////////////////////////////////////////
   //gather the form data
   String linesToShow_s = request.getParameter("itemCount");
   //the number of rows to handle
   int initialLines = ((Integer)request.getAttribute("initialLines")).intValue();
   int linesToShow = initialLines;
   request.setAttribute("linesToShow", new Integer(linesToShow));

   m_formOptions = new Hashtable();

   //SETUP the AND/OR model
   request.setAttribute("model.andOr", andOrModel);

   //SETUP the column selection models

// ### ADDITIONS TO SUPPORT PARENTHESES
   StringCollection[] openParenModels = new StringCollection[2];
   openParenModels[0] = new StringCollection();
   openParenModels[1] = new StringCollection();
   openParenModels[0].add("");
   openParenModels[1].add("");
	for( int p = 0; p < 10; ++p )
	{
		openParenModels[0] = new StringCollection();
		openParenModels[1] = new StringCollection();
		String parenString = "";
		for( int q = 0; q < p; ++q )
		{
			openParenModels[0].add(parenString);
			openParenModels[1].add(parenString);
			parenString += "(";
		}

	}

   StringCollection[] closeParenModels = new StringCollection[2];
   closeParenModels[0] = new StringCollection();
   closeParenModels[1] = new StringCollection();
   closeParenModels[0].add("");
   closeParenModels[1].add("");
	for( int p = 0; p < 10; ++p )
	{
		closeParenModels[0] = new StringCollection();
		closeParenModels[1] = new StringCollection();
		String parenString = "";
		for( int q = 0; q < p; ++q )
		{
			closeParenModels[0].add(parenString);
			closeParenModels[1].add(parenString);
			parenString += ")";
		}

	}
// ### DONE WITH ADDITIONS

   StringCollection[] columnModels = new StringCollection[2];
   columnModels[0] = new StringCollection();
   columnModels[1] = new StringCollection();
   columnModels[0].add("");
   columnModels[1].add("");

   //SETUP the conditional models
   StringCollection[] conditionalModels = new StringCollection[2];
   conditionalModels[0] = new StringCollection();
   conditionalModels[1] = new StringCollection();
   conditionalModels[0].add("");
   conditionalModels[1].add("");

   //SETUP the list of conditionals and complete the models
   Function equalsFunction = null;
   Function inFunction = null;
   Function isnullFunction = null;
   Function orFunction = null;
   if (m_validConditionals == null) {
      m_functionList = m_dataSource.getProperties().getAllFunctions();
      m_validConditionals = m_query.getValidConditionals();
      m_validConditionals = m_validConditionals.getSubsetByPrimaryParmType(Expression.EXP_TYPE_ANY);
      m_validConditionals.sortByName();
      try {
     equalsFunction = m_validConditionals.getSubsetByName("=").elementAt(0);
     inFunction = m_validConditionals.getSubsetByName("IN").elementAt(0);
     int equalsIndex = m_validConditionals.indexOf(equalsFunction);
     int inIndex = m_validConditionals.indexOf(inFunction);
     if (equalsIndex+1 != inIndex) {
        m_validConditionals.removeElementAt(inIndex);
        m_validConditionals.insertElementAt(inFunction,equalsIndex+1);
     }
      } catch (Exception e) {
     //nothing here... just aesthetics...
      }

      String excludeList = bundle.getString("FilterBuilder.Operations.exclude.notrans");
//application.log("Operator exclusion list: " + excludeList);
      StringTokenizer st = new StringTokenizer(excludeList, ",");
      for (; st.hasMoreTokens(); ) {
         String funcName = st.nextToken();
//application.log("  Removing function: " + funcName);
//   m_validConditionals.removeByName(funcName);
     //FunctionList.removeByName(String) uses == instead of equals
     //  so we'll do it the old fashioned way...
     for (int i=m_validConditionals.size()-1;i>=0;i--) {
        if (m_validConditionals.elementAt(i).getName().equals(funcName)) {
           m_validConditionals.removeElementAt(i);
        }
     }
      }
   } else {
      equalsFunction = m_validConditionals.getSubsetByName("=").elementAt(0);
      inFunction = m_validConditionals.getSubsetByName("IN").elementAt(0);
   }
   request.setAttribute("filter.validConditionals", m_validConditionals);
   //get a reference to the ISNULL function instance for later
   isnullFunction = m_functionList.findFunction(FunctionConstants.FUN_CONDITIONAL,
                      "ISNULL",
                      Expression.EXP_TYPE_ANY_INCLUDING_BOOLEAN,
                      Expression.EXP_TYPE_BOOLEAN,
                       1);
   orFunction = m_functionList.findFunction(FunctionConstants.FUN_CONDITIONAL,
                      "OR",
                      Expression.EXP_TYPE_ANY_INCLUDING_BOOLEAN,
                      Expression.EXP_TYPE_BOOLEAN,
                       2);
    if (orFunction == null) { orFunction = m_functionList.getSubsetByName("OR").elementAt(0); }

   //add each conditional to the model
   for (int i=0; i<m_validConditionals.size(); i++) {
      Function func1 = m_validConditionals.elementAt(i);
      conditionalModels[0].add(func1.getFunctionName());
      conditionalModels[1].add(func1.getNiceFunctionName());
   }
   //store the models for later
   request.setAttribute("filter.conditionalModels", conditionalModels);
   request.setAttribute("filter.conditionalModelInterface", conditionalModels[0]);
   request.setAttribute("filter.conditionalDescriptionModel", conditionalModels[1]);

   //Add the data items in the query model to the column selector models
   DataItemList allItems = ((HRVQuery)m_query).getPersistedItemList();
   for (int i=0; i<allItems.size(); i++) {
      DataItem item = allItems.elementAt(i);
//application.log("Adding data item to model: " + item.toString());
      columnModels[0].add(i+"."+item.getDisplayString());

      String itemLabel = getLabelForDataItem((JspDataItem)item, bundle, "ColumnSelector.ColumnListEntry.fmt.txt");

      columnModels[1].add(itemLabel);
   }
   //these should be sorted if we're in the stand-alone filter builder
   if (mode == MODE_WHERE) {
      multiSort(columnModels, 1);
   }
   request.setAttribute("model.columns", columnModels);

//////////////////////////////////////////////////////////////////////
// PROCESS FORM DATA
//////////////////////////////////////////////////////////////////////

try{
      //check to see if there is form data to be processed
      if (action != null) {
     //first, determine how many rows we are looking at
     if (linesToShow_s != null) {
        try {
           linesToShow = Integer.parseInt(linesToShow_s);
        } catch (NumberFormatException nfe) {
           linesToShow = -1;
        }
     }
     //should not happen, but would not hurt to double check
     if (linesToShow < 0) {
        linesToShow = 0;
        linesToShow_s = request.getParameter("item"+linesToShow+".column");
        while (linesToShow_s == null || linesToShow_s.trim().length() == 0) {
           linesToShow++;
           linesToShow_s = request.getParameter("item"+linesToShow+".column");
        }
     }

     if (linesToShow < 1) {
        //this should be an error condition!
     }

     if ("more".equalsIgnoreCase(action)) {
        linesToShow += ((Integer)request.getAttribute("linesToAdd")).intValue();
     }

     request.setAttribute("linesToShow", new Integer(linesToShow));

     //need to collect the values from all of the lines...
//application.log("Processing filters: expecting " + linesToShow + " line(s)");

//////////////////////////////////////////////////////////////////////
// This is where we build the where filter tree based on form data
//////////////////////////////////////////////////////////////////////

     //Gather the list of persisted data items
     DataItemList m_dataItems = m_query.getPersistedItemList();
     String uiSql = "";

     //get the where filter tree
     FilterTree whereFilterTree = m_query.getWhereFilterTree();
     //clear all nodes from the tree
     whereFilterTree.setRoot(null);

     FilterNode lastNode = null;
     FilterNode lastAnd = null;
     FilterNode lastOr = null;

     //step through each row, generate a FilterNode, and add it to the tree
     for (int i=0; i<linesToShow; i++) {

     	//############ CODE TO BRING IN THE OPEN AND CLOSE PARENS ####################
     	String open_p = request.getParameter("item"+i+".openparen");
     	String close_p = request.getParameter("item"+i+".closeparen");
        //String special_p = " ";

        String column_p = request.getParameter("item"+i+".column");
        String not_p        = request.getParameter("item"+i+".not");
        String operator_p   = request.getParameter("item"+i+".operator");

        //int special = i - 1;
        //if(special < 0)
        //	special = 0;
        //System.out.println("spc = "  + special);
        String link_p  = request.getParameter("item"+i+".link");
        String remove_p = request.getParameter("item"+i+".remove");
        request.setAttribute("item"+i+".err", "");

//System.out.println("  ["+i+"]: column=" + column_p + ", not=" + not_p + ", operator="+operator_p+", link="+link_p+", remove="+remove_p);

        //test to see if a column was selected
        if (column_p != null && column_p.trim().length() > 0) {
           ResultItem item = null;
           Expression nodeExpr = null;

           int pos = column_p.indexOf(".");
           String index_s = column_p.substring(0, pos);
           JspDataItem dataItem = null;
           try {
          int index = Integer.parseInt(index_s);
          dataItem = (JspDataItem)m_dataItems.elementAt(index);
          //all JspDataItems are going to have an expression here
          nodeExpr = dataItem.getSafeExpression();
           } catch(NumberFormatException nfe) {
          //shouldn't happen...
           }



           if (nodeExpr != null) {
          //create a new expression list for a compoundExpression
          ExpressionList expressionList = new ExpressionList();

          //###Code to set left parens on complex expressions ####
          //if(open_p != null && !open_p.equals("")){
          //	UnparsedExpression adjustedLeftSide = new UnparsedExpression(open_p + nodeExpr.toString());
          //	expressionList.addElement(adjustedLeftSide);
          //}
          //else{
          	expressionList.addElement(nodeExpr);
          //}

          //get the operator
          Function operator = findFunction(m_validConditionals, operator_p);
          OperandParser op = new OperandParser(m_query);    //BKD:TEST
//////////////////////////////////////////////////////////////////////
          //Check for COLUMN = _BLANK_ case to transform it to IS MISSING
          if (operator == equalsFunction) {
             //operater is EQUALS, check operand
             String value = request.getParameter("item"+i+".operand1");
             //if operand is empty or does not exist, then do transform
             if (op.isMissingValue(nodeExpr, value)) {
            operator = isnullFunction;
             }
          }
//////////////////////////////////////////////////////////////////////



          //get the operands - only collect the appropriate # of operands
          int maxParmDefs = operator.getMaxParmDefs();
          for (int j=1; j<maxParmDefs; j++) {
             FunctionParameter fp = operator.getParmDef(j);
             String value = request.getParameter("item"+i+".operand" + j);

             int dataType = nodeExpr.getDataType();
             //System.out.println("node data type = " + dataType);


             //##### maperr 5/7/04see if this guy is calculated
             if(value.indexOf(HRVParser.COLUMN_PREFIX) != -1){
             	String tempValue = value.substring(value.indexOf(HRVParser.COLUMN_PREFIX) + 1);
             	DataItemList itemList = m_query.getPersistedItemList();

             	for(int x=0; x < itemList.size(); x++){
             	    JspDataItem jspItem = (JspDataItem)itemList.elementAt(x);
             	    boolean isCalculated = isCalculatedColumn(m_query, jspItem);
		    if(tempValue.equalsIgnoreCase(jspItem.getDisplayString()) && isCalculated){
		    	value = tempValue;
		    	break;
		    }
             	}
             }

             if (value == null || value.trim().length() == 0) {
                //incomplete filter!  flag for error and set err msg
            hasError = true;
            request.setAttribute("error.message", bundle.getString( "FilterBuilder.Message.IncompleteFilter.txt" ));
            request.setAttribute("item"+i+".err", "*");
             }


            //###Fix for DEFECT 0220655 - By sinakv
			value = value.trim();
			if ((value != null) && (value.indexOf(",") == 0))
			{
			    value = blankSubstitute + value;
			}
	        //### end of fix

             switch (dataType) {
            case Expression.EXP_TYPE_CHARACTER:
            case Expression.EXP_TYPE_TIME:
            case Expression.EXP_TYPE_TIMESTAMP:
            case Expression.EXP_TYPE_DATE:


               try {
                  // get the browser locale
                  Locale locale = request.getLocale ();
                  // if the locale is not the US then do some processing


                   if(dataType == Expression.EXP_TYPE_DATE){
                   	//if type is date, we need to do some error checking
			//####6/3/2004 maperr code to make this a little more robust with error checking for IN operators
			StringTokenizer tempTokenizer = new StringTokenizer(value, " ");
			int tokenCount = tempTokenizer.countTokens();
			int counter = 0;
			String tempValue = "";
			while(tempTokenizer.hasMoreTokens()){
				String token = tempTokenizer.nextToken();
				int commaIndex = token.indexOf(",");
				if(commaIndex != -1)
					token = token.substring(0, commaIndex);

				token = token.trim();

				counter++;

				if(counter != tokenCount)
					token = token + ",";

				tempValue = tempValue + token;
			}
			if(!tempValue.equals(""))
				value = tempValue;
		    	//##### done with 6/3/2004 fix
                   }


                   if (!locale.equals (Locale.US) && dataType == Expression.EXP_TYPE_DATE)
		   {
		        String newValue = "";
		  	//System.out.println("value = " + value);

		    	StringTokenizer st = new StringTokenizer(value, ",");
		    	while (st.hasMoreTokens()) {
		     		value = st.nextToken();

		      		// strip off leading whitespace
		                if (value.indexOf (" ") >= 0)
		                    value = value.substring (1, value.length ());

		                value = value.replace('\'', ' ');

		                //##6/2/04 maperr ##
		                value = value.trim();
		                if(value.substring(value.length() - 1).equalsIgnoreCase("d"))
		                	value = value.substring(0, value.length()-1);

		              	SimpleDateFormat localeSimpleDateFormat = new SimpleDateFormat
		                    ("ddMMMyyyy", locale);
		              	SimpleDateFormat USSimpleDateFormat = new SimpleDateFormat
		                    ("ddMMMyyyy", Locale.US);
		                try
		                {
		                    java.util.Date oldDate = localeSimpleDateFormat.parse (value);
		                    value = USSimpleDateFormat.format (oldDate);
		                }
		                catch (ParseException pe)
		                {
		                    //System.out.println(pe);
		                    // it's either already english or unparseable by us. Let the query
		                    // facility handle it.
		                }
		                finally {
		                    // always append the current date
		                    newValue += value+",";
		                    //System.out.println("newValue = " + newValue);
		                }
		    	}
		      // strip off trailing comma
		      newValue = newValue.substring(0, newValue.length()- 1);
		      value= newValue;
		      value = value.trim();
 	          }else if(locale.equals (Locale.US) && dataType == Expression.EXP_TYPE_DATE){
 	    		String tempValue = "";
 	    		StringTokenizer st = new StringTokenizer(value, ",");
		    	while (st.hasMoreTokens()) {

 	    		value = st.nextToken();

 	    		//####5/18/2004 maperr #######
 	    		value = value.replace('\'', ' ');
		        value = value.trim();

		        if(value.substring(value.length() - 1).equalsIgnoreCase("d"))
		            value = value.substring(0, value.length()-1);

		        value = value.trim();

		        tempValue += value+",";

		        }

		      tempValue = tempValue.substring(0, tempValue.length()- 1);
		      value= tempValue;
		      value = value.trim();
 	          }


                  ExpressionList testList = null;
                  UnparsedExpression rightSide = null;
                  try{
                  	//if this is a column value. Do an unparsed expression
                  	if(value.substring(0,1).equals(HRVParser.COLUMN_PREFIX)){
                  		rightSide = new UnparsedExpression(value);
                  		expressionList.addElement(rightSide);
                  	}else{
                  		//##replace blanks with commas in dates##
               			if(dataType == Expression.EXP_TYPE_DATE){
               				int commaIndex = value.indexOf(",");
               				if(commaIndex == -1){
               					//no commas exist, replace spaces?
               					value = value.replace(' ', ',');
               				}
               			}
               			//######################################


                  		testList = op.processOperand(dataType, fp.isCommaList(), value);
                  		expressionList.add(testList);
                  	}

                  }catch(ParseException pe){
			//System.out.println("Exception thrown");
			hasError = true;
			request.setAttribute("item"+i+".err", "*");
                  	request.setAttribute("error.message", pe.getMessage());
                  }


               } catch (Exception e) {
                  hasError = true;
                  request.setAttribute("item"+i+".err", "*");
                  //request.setAttribute("error.message", pe.getMessage());
               }
               break;
            default:

               //add the operands to the expression list
               if (fp.isCommaList()) {

                  	ExpressionList el = ((HRVQuery)m_query).createExpressionInstanceList(value);
                  	expressionList.add(el);

               } else {

                  	Expression e = ((HRVQuery)m_query).createExpressionInstance(value);
                  	expressionList.addElement(e);

               }
               break;
             }
          }

////////////////////////////////////////////////////////////////////////////////
// Trying to fix S0126692 - wrapping values in PUT([column], [format])
// BKD:NOTE should it be possible to include prompts in IN lists?
////////////////////////////////////////////////////////////////////////////////
//   if (!"IN".equalsIgnoreCase(operator.getFunctionName())) {
      ExpressionList upList = m_dataSource.getExpressionsByClass(expressionList, ParameterExpression.class);
      if (upList.size() > 0) {
         //expression list contains at least 1 prompt
     ParameterExpression pe = (ParameterExpression)upList.elementAt(0);
     UserPromptBean upb = new UserPromptBean(session);
     upb.setUser(hrvi.getUser(session));
     upb.setMetaKey(pe.getParameter().getName());
//   upb.setMetaLocation(upb.PRIVATE_LOC);  //BKD:FIX - questionable!
     upb.setTrueLocation(nodeExpr.getDataType(), upb.PRIVATE_LOC);
     if (upb.isFormatted()) {
        HRVDataSourceTable hrvDST = null;

        if (nodeExpr instanceof ColumnExpression) {
           Column column = ((ColumnExpression)nodeExpr).getColumn();
           hrvDST = (HRVDataSourceTable)column.getParent().getDataSourceTable();

           TableBean tableBean = (TableBean)hrvDST.getMetaBean();
           Expression leftPutExpression = wrapWithLeftPut(nodeExpr, m_query, tableBean.getColumnFormat(column.getName()));

           //May need to set left paren here...
           expressionList.setElementAt(leftPutExpression, 0);
        }
     }
      }
//   }
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

          CompoundExpression expression = new CompoundExpression(operator, expressionList);

          //this adds a paren that will throw off the balance of the expression

          //expression.setLogicalNegation("NOT".equalsIgnoreCase(not_p));
          //### Fix to keep not from putting extra parens in our sql ###
          String notValue = "";
          if("NOT".equalsIgnoreCase(not_p))
          	notValue = "NOT";


/* BKD:NOTE - per scott
if you always add to the last node that was added when they are "anding", you won't have a problem.  But if you do that with an "OR" node, you need the parens in the sql to match what you're telling the model to do.  If you want to add an "OR" node and not require parens, you'ld have to or him off the root node.
*/

          FilterNode node = new FilterNode(m_query, expression);
          int h = i;
          h++;

          //##maperr 6/10/04 ###
          String nodeString = node.toString();
          String dataString = dataItem.toString();
          if(dataString != null && dataString.substring(dataString.length()-1).equals("1")){
          	//got an alias, so we need the table name
          	int leftPutIndex = nodeString.indexOf("LEFT(PUT(");
          	nodeString = nodeString.substring(nodeString.indexOf(dataString) + dataString.length());
          	//System.out.println("nodeString = " + nodeString);
          	//only whack off the 1 if the item is not in the persisted list
          	DataItemList dataItems = m_query.getPersistedItemList();
          	boolean cutIt = true;
          	List tempItemList = new ArrayList();
          	for(int y=0; y < dataItems.size(); y++){
          	    DataItem dItem = dataItems.elementAt(y);
          	    tempItemList.add(dItem.toString());
          	    if(dItem.toString().equals(dataString)){
			String shortItem = dataString.substring(0, dataString.length()-1);
			if(tempItemList.contains(shortItem))
				cutIt = true;
			else
          			cutIt = false;

          	    }
          	}
          	if(cutIt)
          		dataString = dataString.substring(0, dataString.length()-1);

          	String tableName = "";
          	Expression tempExpression = dataItem.getSafeExpression();
		if (tempExpression instanceof ColumnExpression) {
		    Column column = ((ColumnExpression)tempExpression).getColumn();
		    com.sas.query.models.Table table = column.getParent();
		    tableName = table.getDisplayName();
		}

		String fullAlias = tableName + "." + dataString;

		if(leftPutIndex != -1)
			fullAlias = "LEFT(PUT(" + fullAlias;

		nodeString = fullAlias + " " + nodeString;
          }
          //####################

          String notopen_p = "";
          String notclose_p = "";
          if (notValue.length() > 0 && open_p.length() == 0) {
				 notopen_p = "(";
				 notclose_p = ")";
			 }

          uiSql = uiSql + " " + notValue + " " + notopen_p + open_p + nodeString + close_p + notclose_p + " " + request.getParameter("item"+h+".link");

          //System.out.println("uiSql = " + uiSql);


	      //###Fix for DEFECT 0220655 - By sinakv
          // Resubstituting the unique string with blank
		  StringBuffer uiSqlBuffer = new StringBuffer(uiSql);
		  int indexOfBlank = uiSql.indexOf(blankSubstitute);
		  if (indexOfBlank > -1)
		  {
			  uiSqlBuffer.replace(indexOfBlank,indexOfBlank + blankSubstitute.length(),"");
			  uiSql = uiSqlBuffer.toString();
		  }
	      //### end of fix


          if (whereFilterTree.getRoot() == null) {
             whereFilterTree.setRoot(node);

          } else {
             if ("OR".equalsIgnoreCase(link_p)) {

           	//###### maperr change ##########
           	//if(open_p == null || open_p.equals("")){
           	//    lastNode.addOr(node);
           	//}
           	//else{
           	    whereFilterTree.getRoot().addOr(node);
           	//}

             } else {
            	lastNode.addAnd(node);

             }
          }

          lastNode = node;

           }
        }
     }

//#########################################################################################
//System.out.println("Resulting where string : " + m_query.getWhereString());

//if we have a where clause builder, add the new filter to it.

if(uiSql != null && !uiSql.equals("")){
	String wcbTemp = uiSql.trim();
	//clean up clause
	String sub = wcbTemp.substring(wcbTemp.length() - 4);
	if(sub.indexOf("OR") != -1)
		wcbTemp = wcbTemp.substring(0, wcbTemp.length() - 2);
	else if(sub.indexOf("AND") != -1)
		wcbTemp = wcbTemp.substring(0, wcbTemp.length() - 3);
	else if(sub.indexOf("null") != -1)
		wcbTemp = wcbTemp.substring(0, wcbTemp.length() - 4);
	session.setAttribute("wcb", wcbTemp);
}

TableBean m_tempTableBean = m_query.getWorkingTableBean();
if(m_tempTableBean != null){
	HashMap filterMap = (HashMap)session.getAttribute(m_tempTableBean.getMetaKey());
	if(filterMap != null){

		//make sure it doesnt end in null
		if(uiSql != null && !uiSql.equals("")){
		    uiSql = uiSql.trim();
		    if(uiSql.substring(uiSql.length() -4).equalsIgnoreCase("null"))
		    	uiSql = uiSql.substring(0, uiSql.length() -4);
		}


		//remove any trailing OR's
		String lastChars = uiSql.substring(uiSql.length() - 2);
		if(lastChars != null && lastChars.equals("OR"))
			uiSql = uiSql.substring(0, uiSql.length() - 2);

		String orderandwhere = (String)filterMap.get("orderandgroup");
		if(orderandwhere != null && !orderandwhere.equals(""))
			uiSql = uiSql + orderandwhere;


		filterMap.put("_snapshot", uiSql);
		session.setAttribute(m_tempTableBean.getMetaKey(), filterMap);
	}
}



//###maperr 5/13/04 validate this string. If parens do not balance, kick back #########
boolean validstring = validateParens(uiSql);; //some function call
if(!validstring){
	String unbalanceParensMessage = bundle.getString("Unbalanced.Parens.txt");

	String fullPath = "";

	//need to check the session key to see where we came from...
	if(m_sessionKey.indexOf("wcbKey") != -1){
	    //go to subset stuff
	    fullPath = "../Query/Where.jsp?hideQueryLimit=y&sessionkey="+m_sessionKey+"&clause=&error=" + unbalanceParensMessage;

	}else{
	    //stay in query
	    String forwardpage = "../Query/Step2.jsp?error=" + unbalanceParensMessage +"&";
	    String paramString = buildParameterString(riders);
	    fullPath = forwardpage + paramString;
	}

	response.sendRedirect(response.encodeRedirectURL(fullPath));
	return;
}

session.removeAttribute("initialLoad");

//#########################################################################################
     //update the table bean
     TableBean queryTable = m_query.getWorkingTableBean();

     if (queryTable != null)
        m_dataSource.updateTableBean(queryTable, m_query);
     firePropertyChanges(m_query);

      } else {
         fromModel = true;
      }
} catch (Exception e) {
System.out.println("ERROR! " + e.getMessage());
e.printStackTrace();
}
//////////////////////////////////////////////////////////////////////

   // Quick check to see if we can display or not based on # of items in
   // persisted items list
   if (m_query.getPersistedItemList().size() == 0) {
      stepToGoto = "selcols";
      riders.put("msg", "NoneSelected.txt");
   }

   if ("editsql".equals(stepToGoto)) {
      riders.put("returnTo", request.getAttribute("topic"));
   }

   if ((stepToGoto != null) && (hasError == false)) {
      String nextURL = null;

      if (mode == MODE_WHERE && !"editsql".equals(stepToGoto)) {
         String newWhereString = "";

         //check for cancel
     if ("whereCancel".equals(stepToGoto)) {
        //user has cancelled edit - revert to original where string
        //#####4/7/04
        m_query.setWhereString(((WhereClauseBuilder)m_queryControl).getOriginalClause());
     }

     newWhereString = m_query.getWhereString();

     //compose return url
         String urlFormat = ((WhereClauseBuilder)m_queryControl).getReturnURLFormat();
     if (urlFormat != null) {
        Object[] args = {
            m_sessionKey,
            newWhereString
             };
        nextURL = java.text.MessageFormat.format(urlFormat, args);

%>
<SCRIPT LANGUAGE="JavaScript">
top.document.location.href='<%= nextURL %>';
</SCRIPT>
<%
        return;
         }
      } else {
         String urlKey = ("Query.Step."+stepToGoto+".url");
     nextURL = bundle.getSentence(urlKey);
     if (urlKey.equals(nextURL))
        nextURL = null;
      }

      if (mode == MODE_WHERE) {
         riders.put("updateMenu", request.getAttribute("updateMenu"));
      }

      if (nextURL == null) {
         nextURL = "";  //BKD:FIX should this be an error instead?
     //BKD:FIX If we keep this warning, should we localize the message?
//   application.log("Could not find URL for step=("+stepToGoto+")");
      }
      //there may be some parameters we need to add to the next URL
      String paramString = buildParameterString(riders);

      //there might be some parameters already on the URL
      if (nextURL.indexOf("?") == -1)
     nextURL = nextURL + "?" + paramString.toString();
      else
     nextURL = nextURL + "&" + paramString.toString();


      // ########## redirect to other pages gets done here.....
      response.sendRedirect(response.encodeRedirectURL(nextURL));
      return;
   }

//////////////////////////////////////////////////////////////////////
//  We're going to the display for this step now
//////////////////////////////////////////////////////////////////////

   //We should 1st check to see if the filter is too complex for this visual
////////////////////////////////////////////////////////////////////////////////
   boolean tooComplex = false;

   //If we're not from the model, then there was probably an error during
   //  user input.  If so, then we shouldn't force them into the editor if
   //  it's something simple like an incomplete filter or badly formatted
   //  values.
   if (fromModel) {
     FilterTree filterTree = m_query.getWhereFilterTree();
     if (filterTree != null) {
     FilterNode rootNode = filterTree.getRoot();
     FilterNode andNode = null;
     FilterNode orNode = null;
     Expression nodeData = null;

     //step through the nodes - there should be no forks, only 1 path to
     //follow.
     while (rootNode != null) {
        //need to check out the expression to see if it's simple
        nodeData = (Expression)rootNode.getNodeData();
        if (nodeData instanceof CompoundExpression) {
           CompoundExpression compExp = (CompoundExpression)nodeData;
           Function operator = compExp.getCurrentFunction();
        //////////////////////////////////////////////////////////////////////////////// BKD:BUGFIX 09OCT2002
       orFunction = m_functionList.getSubsetByName("OR").elementAt(0);

        if (operator == orFunction || orFunction.equals(operator)) {
      //System.out.println("Found OR operator - attempting to split expression, op= " + operator);
        ExpressionList expList = compExp.getParameters();
        Expression leftExpression = expList.elementAt(0);
        Expression rightExpression = expList.elementAt(1);
        if ( (leftExpression instanceof CompoundExpression) && (rightExpression instanceof CompoundExpression) ){
            //we need to take the current node and break it into 2 nodes ORed together

            rootNode.setNodeData(leftExpression);
            FilterNode newNode = new FilterNode(m_query, rightExpression);
            newNode.setOr(rootNode.getOr());
            rootNode.setOr(newNode);
            continue;   //try the loop again...
        } else {
            tooComplex = true;  //only supporting OR between compound expressions
            break;
        }
        }
        //////////////////////////////////////////////////////////////////////////////// BKD:BUGFIX 09OCT2002
           //check the operator to see if it's in our list - if not, then
           //go to the advanced view.
           if (operator == null || findFunction(m_validConditionals, operator.getFunctionName()) == null) {
          if (operator != isnullFunction && !(isnullFunction.equals(operator)) ) {
             //the current function will not be in our list, so fail
             tooComplex = true;
             break;
          }
           }
        } else {
           //the UI will only create CompoundExpressions.  If the
           //expression isn't of that type, then we won't handle it
           //correctly.
           tooComplex = true;
           break;
        }

        //then verify the simple path
        andNode = rootNode.getAnd();
        orNode = rootNode.getOr();

        if (andNode != null && orNode != null) {
           tooComplex = true;
           break;
        } else if (andNode != null) {
           rootNode = andNode;
        } else {
           rootNode = orNode;
        }
     }
      }
   }

   //we now need to see if we are indeed to complex

   String value_check = (String)session.getAttribute("complex_filter_on");
   if(value_check != null && value_check.equals("on"))
       tooComplex = true;
   else
   	   tooComplex = false;

   if (tooComplex) {
      //This query should be shown with the advanced view.
      riders.put("returnTo", request.getAttribute("topic"));
      riders.put("adv", "y");
      String nextURL = getRedirectURL(bundle, "editsql", riders);

      //send URL redirect to browser and stop processing
      response.sendRedirect(response.encodeRedirectURL(nextURL));
      return;
   }
////////////////////////////////////////////////////////////////////////////////

   //finally, setup the transformation beans for displaying the page
   //  the tricky part - use the model for the values unless there was an
   //    error processing the form data.  In that instance, we should use the
   //    form data since the query model won't have what the user specified.
   String m_notBoxLabel     = bundle.getString( "FilterBuilder.NotButton.txt" );

   if (fromModel) {
   	//figure out how to rewrite to attribute filter page

      //Seems to be correct here...

      FilterTree filterTree = m_query.getWhereFilterTree();

      FilterNode[] nodes = filterTree.getNodesArray();

      linesToShow = Math.max(nodes.length + 1, initialLines);
      request.setAttribute("linesToShow", new Integer(linesToShow));

//#### Get the filter off the map ########
TableBean m_tempTableBean = m_query.getWorkingTableBean();
HashMap filterMap = null;
if(m_tempTableBean != null)
	filterMap = (HashMap)session.getAttribute(m_tempTableBean.getMetaKey());
else{
	filterMap = new HashMap();
	filterMap.put("_snapshot", "");
	filterMap.put("orderandgroup", "");
}

String tempWhere = "";
if(filterMap != null){
	//remove the order by stuff
	String orderby = (String)filterMap.get("orderandgroup");
	tempWhere = (String)filterMap.get("_snapshot");


	if(orderby != null && !orderby.equals("")){
		int index = tempWhere.indexOf(orderby);
		if(index != -1)
			tempWhere = tempWhere.substring(0, index);
	}
}
//########################################

//lets see if we have a clause on the request...
if(tempWhere == null || tempWhere.equals("")){
	String subset = (String)request.getAttribute("clause");

	if(subset != null && !subset.equals("")){
		tempWhere = subset;
	}
	else{
	    //lets see if its on the session
	    subset = (String)session.getAttribute("wcb");
	    if(subset != null && !subset.equals(""))
	    	tempWhere = subset;
	}

}


//System.out.println("tempWhere = " + tempWhere);
List operands = new ArrayList();
operands.add(0, new Choicebox());
for (int i=0; i<linesToShow; i++) {
     Choicebox andOrChoicebox = new Choicebox();
        andOrChoicebox.setModelInterface(andOrModel);
        int spc = i + 1;
        andOrChoicebox.setName("item"+spc+".link");
        //### No Selection for now ###
        operands.add(i + 1, andOrChoicebox);
// ### ADDITIONS TO SUPPORT PARENTHESES
     Choicebox openparenChoicebox = new Choicebox();
        openparenChoicebox.setModelInterface(openParenModels[0]);
        openparenChoicebox.setDescriptionModel(openParenModels[1]);
        openparenChoicebox.setName("item"+i+".openparen");
        //openparenChoicebox.setCustomAttributes("OnChange=\"OnChangeOpenParen("+i+")\" ");
// ### DONE WITH ADDITIONS
     Choicebox columnChoicebox = new Choicebox();
        columnChoicebox.setModelInterface(columnModels[0]);
        columnChoicebox.setDescriptionModel(columnModels[1]);
        columnChoicebox.setName("item"+i+".column");
        columnChoicebox.setCustomAttributes("OnChange=\"OnChangeColumn("+i+")\" ");
        //System.out.println("SAND>> columnModels[0] = " + columnModels[0]);
        //System.out.println("SAND>> columnModels[1] = " + columnModels[1]);

     Choicebox conditionalChoicebox = new Choicebox();
        conditionalChoicebox.setModelInterface(conditionalModels[0]);
        conditionalChoicebox.setDescriptionModel(conditionalModels[1]);
        conditionalChoicebox.setName("item"+i+".operator");
        conditionalChoicebox.setCustomAttributes("OnChange=\" OnChangeOperator("+i+")\"");
     Checkbox  notCheckbox = new Checkbox();
        notCheckbox.setLabel(m_notBoxLabel);
        notCheckbox.setValue("NOT");
        notCheckbox.setName("item"+i+".not");
     TextEntry valueTextEntry = new TextEntry();
        valueTextEntry.setSize(20);
        valueTextEntry.setMaximumLength(200);
        valueTextEntry.setName("item"+i+".operand1");
// ### ADDITIONS TO SUPPORT PARENTHESES
     Choicebox closeparenChoicebox = new Choicebox();
        closeparenChoicebox.setModelInterface(closeParenModels[0]);
        closeparenChoicebox.setDescriptionModel(closeParenModels[1]);
        closeparenChoicebox.setName("item"+i+".closeparen");
        //closeparenChoicebox.setCustomAttributes("OnChange=\"OnChangeCloseParen("+i+")\" ");
// ### DONE WITH ADDITIONS

         if (i < nodes.length) {
        Expression nodeData = nodes[i].getNodeData();
        if (nodeData instanceof CompoundExpression) {
           boolean notSection = false;
           CompoundExpression expression = (CompoundExpression)nodeData;

 //############ New code maperr ######################


 //if the filter is too complex, we dont need to do this...




	   int numberOfOpenParens = 0;
	   int numberOfCloseParens = 0;

	   //if number of open and close parens is 0. Check the snapshot for leading parens

	   //chop the where up into sections
	   int andIndex = -1;
	   int orIndex = -1;
	   int useIndex = 0;
	   boolean isIn = false;
	   //###Modified by sinsat on 27Aug2004 - "AND", "OR" replaced by " AND ", " OR " respectively. This is a fix to So265914.
	   andIndex = tempWhere.indexOf(" AND ");
	   orIndex = tempWhere.indexOf(" OR ");

       //###Modified by sinsat on 27Aug2004 - Increment useIndex further by one. This is a fix to So265914.
	   if(andIndex < orIndex){
		useIndex = andIndex + 4;
		if(andIndex == -1)
			useIndex = orIndex + 3;
	   }
	   else if(orIndex < andIndex){
		useIndex = orIndex + 3;
		if(orIndex == -1)
			useIndex = andIndex + 4;
	   }else if(orIndex == -1 && andIndex == -1){
		//we are at the end
		useIndex = tempWhere.length();
	   }

//	   System.out.println("Before change, tempWhere = " + tempWhere);
	   String section = tempWhere.substring(0, useIndex);
	   tempWhere = tempWhere.substring(useIndex).trim();
//	   System.out.println("After change, tempWhere = " + tempWhere);
// 	   System.out.println("section = " + section);

   	   //###Added by sinsat on 06SEP2004 - start
			//Following few lines of code are moved here from line near 1340.
			Expression itemExpression = expression.getParameter(0);
           	itemExpression = unwrapIfHasLeftPut(itemExpression, m_query);
           	JspDataItem item = getDataItem(m_query, itemExpression, true);

   	   //Added by sinsat on 14FEB2005 for NOT operator- start
	         DataItemList tempItemList = m_query.getPersistedItemList();
	         JspDataItem tempItem = null;
			 if(item == null && tempItemList.size() > 0){
	           	 	for (int j=0; j<tempItemList.size(); j++) {
			           	DataItem existingItem = tempItemList.elementAt(j);
       		   		tempItem = (JspDataItem)existingItem; //found it - save reference
					if(tempItem.toString() != tempItem.getExpression().toString()){
						item = tempItem;
					}
             		}
             	 }
   	   //Added by sinsat on 14FEB2005 for NOT operator- end


           	String itemID = "";
		    if (item != null) {
   				itemID = item.getDisplayString();
			}

   	   		boolean calculatedFlag = isCalculatedColumn(m_query, item);
   	   		//System.out.println(">> m_query = " + m_query);
	   		//System.out.println(">> item = " + item.toString());
	   		//System.out.println(">> calculatedFlag = " + calculatedFlag);
   	   //###Added by sinsat on 06SEP2004 - end


	   if(section.indexOf(" IN ") != -1)
		isIn = true;
	   if(section.indexOf("NOT ") != -1)
		notSection = true;

	   int leftPutIndex = section.indexOf("LEFT(PUT(");
	   if(leftPutIndex != -1){
	       //clean this up for the parser
	       String front = section.substring(0, leftPutIndex);
	       String back = section.substring(section.indexOf("))") + 2);
	       String columnId = section.substring(leftPutIndex + 9, section.indexOf(","));
	       section = front + columnId + back;

	   }

	   String info = "";

	   for(int k=0; k < section.length(); k++){
		String value = section.substring(k, k + 1);
		if(value.equals("("))
			numberOfOpenParens++;
		else if(value.equals(")"))
			numberOfCloseParens++;
		else{
		    //created string without parens
		    info = info + value;
		}
	   }

	   //#### The query loads funny in some instances. The ui will be based off of the saved where string ####
	   info = info.trim();
	   String uiColumn = "";
	   String uiOperation = "";
	   String uiValue = "";
	   String uiNextOperand = "";
	   String uiNot = "";

//		System.out.println("Info : "  +info);

	   for(int r=0; r < 4; r++){
		//System.out.println("info = " + info);
	   	int index = info.indexOf(" ");
	   	String value = "";

		//###if condition modified by sinsat on 06SEP2004.
	   	if(index != -1 && calculatedFlag == false){
	   		if(r != 2 && r != 3){
	   			value = info.substring(0, index);
	   			info = info.substring(index);
	   			info = info.trim();
	   			//System.out.println("After>> value = " + value);
	   		}else if(r == 2){
	   			//time to determine the actual value for this item
	   			//###Modified by sinsat on 27Aug2004. This is a fix to So265914.
	   			int andIndex1 = info.indexOf(" AND");
	   			int orIndex1 = info.indexOf(" OR");
	   			if(andIndex1 != -1){
	   				value = info.substring(0, andIndex1);
	   				//System.out.println("value = " + value);
	   			}
	   			else if(orIndex1 != -1){
	   				value = info.substring(0, orIndex1);
	   				//System.out.println("value = " + value);
	   			}
	   			else{
	   				value = info;
	   				//System.out.println("value = " + value);
	   			}
	   			//###Added by sinsat for S0272446 on 16DEC2004 - Start
	   			int grpIndex = value.indexOf("GROUP BY");
	   			int ordIndex = value.indexOf("ORDER BY");
	   			if(grpIndex != -1 || ordIndex != -1){
					//If both GroupBy and OrderBy present in query then GroupBy always appears first.
					if(grpIndex != -1){
	   					value = value.substring(0,grpIndex);
	   				}else if(grpIndex == -1 && ordIndex != -1){
	   					value = value.substring(0,ordIndex);
	   				}
	   			}
	   			//###Added by sinsat for S0272446 on 16DEC2004 - End

	   		}else if(r == 3){
	   			//###Modified by sinsat on 27Aug2004 - "OR" replaced by " OR ". This is a fix to So265914.
	   			//System.out.println("info = " + info);
	   			int orIndex1 = info.indexOf(" OR");

	   			//###Added by sinsat for S0272446 on 16DEC2004 - Start
				int orderByIndex = info.indexOf(" ORDER BY");
				if(orIndex1 == orderByIndex){
					orIndex1 = -1;
				}
	   			//###Added by sinsat for S0272446 on 16DEC2004 - End

	   			//System.out.println("orIndex1 = " + orIndex1);
	   			if(orIndex1 == -1){
   					value = "AND";
	   			}
	   			else{
	   				value = "OR";
	   			}
	   		}
	   	}else if(index != -1 && calculatedFlag == true){
		//###Added by sinsat on 06SEP2004 - start
	   		if(r != 2 && r != 3){
	   			//System.out.println("Before>>info = " + info);
	   			//System.out.println("Before>>section = " + section);
				int parenStartIndex = section.indexOf("(");
	   			int parenEndIndex = section.indexOf(")");

	   			operatorIndex = section.indexOf("<=");
	   			if(operatorIndex == -1){
	   				operatorIndex = section.indexOf("<");
	   			}
	   			if(operatorIndex == -1){
	   				operatorIndex = section.indexOf("=*");
	   			}
	   			if(operatorIndex == -1){
	   				operatorIndex = section.indexOf(">=");
	   			}
	   			if(operatorIndex == -1){
	   				operatorIndex = section.indexOf(">");
	   			}
	   			if(operatorIndex == -1){
	   				operatorIndex = section.indexOf("=");
	   			}
	   			if(operatorIndex == -1){
	   				operatorIndex = section.indexOf("CONTAINS ");
	   			}
	   			if(operatorIndex == -1){
	   				operatorIndex = section.indexOf("LIKE ");
	   			}
	   			if(operatorIndex == -1){
	   				operatorIndex = section.indexOf("IN (");
	   			}
	   			if(operatorIndex == -1){
	   				operatorIndex = section.indexOf("IS ");
	   			}
				//System.out.println("operatorIndex = " + operatorIndex);


	   			if(r == 0){
					if(operatorIndex != -1){
						//###Done by sinsat - 16SEP2004: start
				   			//value = section.substring(parenStartIndex, operatorIndex);
				   			if(parenStartIndex != -1){
				   				value = section.substring(parenStartIndex, operatorIndex);
				   			}else{
					   			//value = section.substring(0, operatorIndex);
				   			}


						//###Done by sinsat - 16SEP2004: end
			   			info = section.substring(operatorIndex);
			   			info = info.trim();
					}else{
						//Should not go here
			   			//value = section.substring(parenStartIndex, parenEndIndex);
			   			//info = section.substring(parenEndIndex+1);
			   			//info = info.trim();
					}

					//System.out.println("After>> info = " + info);
					//System.out.println("After>> value = " + value);

					   for(int f=0; f < value.length(); f++){
							String factor = value.substring(f, f + 1);
							if(factor.equals(")")){
								numberOfOpenParens--;
								numberOfCloseParens--;
							}
					   }
	   			}
	   			if(r == 1){
					value = info.substring(0, index);
	   				if(isIn){
						info = info.substring(index+2);
		   			}
		   			else{
						info = info.substring(index);
		   			}
		   			info = info.trim();
	   			}
	   		}else if(r == 2){
	   			//time to determine the actual value for this item
	   			//###Modified by sinsat on 27Aug2004. This is a fix to So265914.
	   			int andIndex2 = info.indexOf(" AND");
	   			int orIndex2 = info.indexOf(" OR");
	   			if(andIndex2 != -1){
	   				value = info.substring(0, andIndex2);
	   			}
	   			else if(orIndex2 != -1){
	   				value = info.substring(0, orIndex2);
	   			}
	   			else{
	   				value = info;
	   			}

				if (value.endsWith(")")){
		   				int closeParenIndex = value.indexOf(")");
		   				value = value.substring(0, closeParenIndex);
		   		}

		   		//###Added by sinsat for S0272446 on 16DEC2004 - Start
	   			int grpIndex = value.indexOf("GROUP BY");
	   			int ordIndex = value.indexOf("ORDER BY");
	   			if(grpIndex != -1 || ordIndex != -1){
					//If both GroupBy and OrderBy present in query then GroupBy always appears first.
					if(grpIndex != -1){
	   					value = value.substring(0,grpIndex);
	   				}else if(grpIndex == -1 && ordIndex != -1){
	   					value = value.substring(0,ordIndex);
	   				}
	   			}
	   			//###Added by sinsat for S0272446 on 16DEC2004 - End

	   		}else if(r == 3){
	   			//###Modified by sinsat on 27Aug2004 - "OR" replaced by " OR ". This is a fix to So265914.
	   			//System.out.println(">>>info = " + info);
	   			int orIndex2 = info.indexOf(" OR");

	   			//###Added by sinsat for S0272446 on 16DEC2004 - Start
				int orderByIndex = info.indexOf(" ORDER BY");
				if(orIndex2 == orderByIndex){
					orIndex2 = -1;
				}
	   			//###Added by sinsat for S0272446 on 16DEC2004 - End

	   			//System.out.println("orIndex2 = " + orIndex2);
	   			if(orIndex2 == -1){
   					value = "AND";
	   			}
	   			else{
	   				value = "OR";
	   			}
	   		}
	   	//###Added by sinsat on 06SEP2004 - end

	   	}else{
	   		value = info;
	   		//###Added by sinsat on 06SEP2004 - start
	   		if(index == -1 && calculatedFlag == true){
				if (value.endsWith(")")){
		   				int closeParenIndex = value.indexOf(")");
		   				value = value.substring(0, closeParenIndex);
		   		}
	   		}
		   	//###Added by sinsat on 06SEP2004 - end
	   	}


	   	if(value.equals("NOT")){
	   		//move ahead a little
	   		index = info.indexOf(" ");
	   		value = info.substring(0, index);
	   		info = info.substring(index);
	   		info = info.trim();
	   	}

	   	if(value.equals("IN")){
	   		//take off the added parens
	   		numberOfOpenParens--;
	   		numberOfCloseParens--;
	   		//System.out.println("section = " + section);
			String inSection = "";
			try{
				inSection = section.substring(section.indexOf("IN (") + 4, section.indexOf(")"));
			}catch(Exception e){
				//an error has occured and the string is empty
				inSection = "";
			}

	   		//System.out.println("inSection = " + inSection);
	   		uiValue = inSection;

	   	}

	   	if(r == 0){
	   		uiColumn = value;
   		}
	   	else if(r == 1){
	   		uiOperation = value;

	   		//####Start - Added by sinsat on 11Aug2004 for fixing S0263897.
	   		if (uiOperation.equalsIgnoreCase("IS")){
	   			uiOperation = "=";
	   		}
	   		//####End - Added by sinsat on 11Aug2004 for fixing S0263897.
	   	}
	   	else if(r == 2){
	   		if(uiValue.equals("")){

	   			//####Start - Added by sinsat on 11Aug2004 for fixing S0263897
	   			//strip off trailing space
	   			value = value.trim();
	   			if(!value.equalsIgnoreCase("NULL")){
		   			uiValue = value;
	   			}
	   			//####End - Added by sinsat on 11Aug2004 for fixing S0263897
	   		}
	   	}
	   	else if(r == 3){
	   		//System.out.println("value = " + value + " Done");
	   		if(value.equals("AND") || value.equals("OR"))
	   			uiNextOperand = value;
	   		else
	   			uiNextOperand = "AND";
	   	}
	   }

	   //###Added by sinsat on 06SEP2004 - start
	   	try{
			intInfo = Integer.parseInt(uiValue);
			//System.out.println("Value of intInfo = " + intInfo);
	   	}
		catch(NumberFormatException e){
			//System.out.println("Invalid format");
			intInfo = 0;
		}
	   //###Added by sinsat on 06SEP2004 - end


	   //System.out.println("---");
	   //System.out.println("uiColumn = " + uiColumn);
	   //System.out.println("uiOperation = " + uiOperation);
	   //System.out.println("uiValue = " + uiValue);
	   //System.out.println("uiNextOperand = " + uiNextOperand);
	   //System.out.println("---");

//		Following line is commented by sinsat on 06SEP2004 and moved to line near 1115
//     	Expression itemExpression = expression.getParameter(0);

	   openparenChoicebox.setSelectedIndex( numberOfOpenParens );
       closeparenChoicebox.setSelectedIndex( numberOfCloseParens );

 //###################################################


	  //##### Ok. Having to parse this thing out now #####

           //if (nodes[i].getOrParent() != null)


          //### FIX
          if(uiNextOperand.equals("OR"))
          	andOrChoicebox.setSelectedIndex(1);
          else
          	andOrChoicebox.setSelectedIndex(0);

          operands.add(i + 1, andOrChoicebox);


           //String columnName = String.valueOf(getPositionForDataItem(m_query, item))+"."+itemID;
           //columnChoicebox.setSelectedIndex(columnModels[0].getIndex(columnName,0));

	   int uiIndex = uiColumn.indexOf(".");

	   //###If Condition altered by sinsat on 06SEP2004.
	   if(uiIndex != -1 && calculatedFlag == false){
	   		uiColumn = uiColumn.substring(uiIndex + 1);
	   }



	   //System.out.println("SAND>>m_query = " + m_query.toString());
	   //System.out.println("SAND>>uiColumn = " + uiColumn);
	   //System.out.println("SAND>>item = " + item);

	   //###If Condition added by sinsat on 06SEP2004 - start
	   if (calculatedFlag == true){
			//uiColumn = item.toString();
			//Added by sinsat for S0267971 on 16SEP2004  - Start

	   		String formattedQuery = getFormattedQuery(uiColumn, m_query.getSql());
	   		uiColumn = getItemFromCalculated(uiColumn, formattedQuery);
			//Added by sinsat for S0267971 on 16SEP2004  - End

	   		//System.out.println("** UICOLUMN "+uiColumn);

	   }
	   //###If Condition added by sinsat on 06SEP2004 - end

	   String columnName = String.valueOf(getPositionForDataItem(m_query, uiColumn, item))+"."+uiColumn;
	   //System.out.println("SMART1>> " + String.valueOf(getPositionForDataItem(m_query, uiColumn, item)));
	   //System.out.println("columnName = " + columnName);

	   if(isAlias){
	   	columnName = columnName + "1";
	   	isAlias = false;
	   }
	   columnChoicebox.setSelectedIndex(columnModels[0].getIndex(columnName,0));

           //notCheckbox.setSelected(expression.isLogicalNegation());
           notCheckbox.setSelected(notSection);
           //need to set selected operator


           //String funcName = null;
           //if (expression.getCurrentFunction() == isnullFunction) {
          //	funcName = equalsFunction.getFunctionName();
           //} else {
          //	funcName = expression.getCurrentFunction().getFunctionName();
           //}
           //conditionalChoicebox.setSelectedIndex(conditionalModels[0].getIndex(funcName, 0));

           conditionalChoicebox.setSelectedIndex(conditionalModels[0].getIndex(uiOperation, 0));


           //generate text for operand field
           //setTextFromExpression(m_query, valueTextEntry, expression, 1);
           valueTextEntry.setText(uiValue);


        } else {
           //huh, a filter not based on a CompoundExpression.  That is
           //most likely due to an edit SQL error.
           //Force to advanced view?
        }
     }
     //request.setAttribute("item"+ i +".link", andOrChoicebox);
// ### ADDITIONS TO SUPPORT PARENTHESES
     request.setAttribute("item"+i+".openparen", openparenChoicebox);
// ### DONE WITH ADDITIONS
     request.setAttribute("item"+i+".column", columnChoicebox);
     request.setAttribute("item"+i+".not", notCheckbox);
     request.setAttribute("item"+i+".operator", conditionalChoicebox);
     request.setAttribute("item"+i+".operand1", valueTextEntry);
// ### ADDITIONS TO SUPPORT PARENTHESES
     request.setAttribute("item"+i+".closeparen", closeparenChoicebox);
// ### DONE WITH ADDITIONS



      }
      //###This updates the AND/OR choicebox's ###
      for(int a=0; a < operands.size(); a++){
      	request.setAttribute("item"+ a +".link", (Choicebox)operands.get(a));
      }



   } else {
   for (int i=0; i<linesToShow; i++) {
      Choicebox andOrChoicebox = new Choicebox();
     andOrChoicebox.setModelInterface(andOrModel);
     andOrChoicebox.setName("item"+i+".link");
      Choicebox columnChoicebox = new Choicebox();
     columnChoicebox.setModelInterface(columnModels[0]);
     columnChoicebox.setDescriptionModel(columnModels[1]);
     columnChoicebox.setName("item"+i+".column");
     columnChoicebox.setCustomAttributes("OnChange=\"OnChangeColumn("+i+")\" ");


           Choicebox openparenChoicebox = new Choicebox();
          openparenChoicebox.setModelInterface(openParenModels[0]);
          openparenChoicebox.setDescriptionModel(openParenModels[1]);
          openparenChoicebox.setName("item"+i+".openparen");
     //openparenChoicebox.setCustomAttributes("OnChange=\"OnChangeOpenParen("+i+")\" ");



           Choicebox closeparenChoicebox = new Choicebox();
          closeparenChoicebox.setModelInterface(closeParenModels[0]);
          closeparenChoicebox.setDescriptionModel(closeParenModels[1]);
          closeparenChoicebox.setName("item"+i+".closeparen");
     //closeparenChoicebox.setCustomAttributes("OnChange=\"OnChangeCloseParen("+i+")\" ");



      Choicebox conditionalChoicebox = new Choicebox();
     conditionalChoicebox.setModelInterface(conditionalModels[0]);
     conditionalChoicebox.setDescriptionModel(conditionalModels[1]);
     conditionalChoicebox.setName("item"+i+".operator");
     conditionalChoicebox.setCustomAttributes("OnChange=\" OnChangeOperator("+i+")\" ");
      Checkbox  notCheckbox = new Checkbox();
     notCheckbox.setLabel(m_notBoxLabel);
     notCheckbox.setValue("NOT");
     notCheckbox.setName("item"+i+".not");
      TextEntry valueTextEntry = new TextEntry();
     valueTextEntry.setSize(20);
     valueTextEntry.setMaximumLength(200);
     valueTextEntry.setName("item"+i+".operand1");

      m_formOptions.put(andOrChoicebox.getName(), andOrModel);
      m_formOptions.put(columnChoicebox.getName(), columnModels[0]);
      m_formOptions.put(conditionalChoicebox.getName(), conditionalModels[0]);

      m_formOptions.put(openparenChoicebox.getName(), openParenModels[0]);
      m_formOptions.put(closeparenChoicebox.getName(), closeParenModels[0]);

      fillInValue(request, andOrChoicebox);
      fillInValue(request, openparenChoicebox);
      fillInValue(request, closeparenChoicebox);
      fillInValue(request, columnChoicebox);
      fillInValue(request, conditionalChoicebox);
      fillInValue(request, notCheckbox);
      fillInValue(request, valueTextEntry);
   }
   }
session.setAttribute("initialLoad", "true");
   pageContext.forward((String)request.getAttribute("viewURL"));
%>
<%!
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
public boolean validateParens(String filter){
    int openParens = 0;
    int closeParens = 0;

    for(int i=0; i < filter.length(); i++){
    	String character = filter.substring(i, i+1);
    	if(character.equals("("))
    	    openParens++;

    	if(character.equals(")"))
    	    closeParens++;
    }

    if(openParens == closeParens)
    	return true;
    else
    	return false;
}

public Function findFunction(FunctionList fl, String name)
{
   FunctionList candidates = fl.getSubsetByName(name);
   if (candidates.size() == 0)
      return null;

   return candidates.elementAt(0);
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
public void fillInValue(HttpServletRequest request, BaseTransformation bean)
      throws java.io.IOException
{
   String name = bean.getName();

   String value = request.getParameter(name);

   if (bean instanceof BaseInput) {
      ((BaseInput)bean).setText(value);
   } else if (bean instanceof Choicebox) {
      StringCollection sc = (StringCollection)m_formOptions.get(name);
      if (sc.contains(value))
         ((Choicebox)bean).setSelectedIndex(sc.getIndex(value, 0));
   } else if (bean instanceof Listbox) {
      StringCollection sc = (StringCollection)m_formOptions.get(name);
      String [] vals = request.getParameterValues(name);
      StringCollection values = new StringCollection(vals);
      if (values.count() > 0 )
         ((Listbox)bean).setSelectedItems(values);
   } else if (bean instanceof Checkbox) {
      ((Checkbox)bean).setSelected( (value != null) );
   }

   request.setAttribute(name, bean);
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
public void setTextFromExpression(HRVQuery query, TextEntry textEntry, CompoundExpression exp, int defNum) {
   if (exp == null || textEntry == null)
      return;       //shouldn't have come here anyway...

   Expression lhsExp = exp.getParameter(0);
   Expression rhsExp = null;
   Function operator = exp.getCurrentFunction();
   int maxParmDefs = operator.getMaxParmDefs();
   ExpressionList expList = exp.getParameters();
   FunctionParameter parmDef = null;
   StringBuffer textBuf = new StringBuffer();

   if (defNum < maxParmDefs) {
      parmDef = operator.getParmDef(defNum);
      if (parmDef.isCommaList()) {
         for (int i=defNum; i<expList.size(); i++) {
            rhsExp = expList.elementAt(i);
            if (i > defNum)
               textBuf.append(", ");

            textBuf.append(getTextForExpression(query, lhsExp, rhsExp));
         }
      } else {
         if (defNum < expList.size())
            rhsExp = expList.elementAt(defNum);
         textBuf.append(getTextForExpression(query, lhsExp, rhsExp));
      }
   } else {
      if (maxParmDefs > 1)
     textBuf.append(getTextForExpression(query, lhsExp, null));
   }

   String rightHandText = textBuf.toString();
   //System.out.println("right hand = " + rightHandText);
   textEntry.setText(rightHandText);
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
public String getTextForExpression(HRVQuery query, Expression lhs, Expression rhs) {
   if (rhs == null) {
      int type = lhs.getDataType();
      FunctionParameter funcParm = new FunctionParameter("", "", type);
      return funcParm.generateTemplate().toString();
   } else {
// ### MODIFICATIONS FOR COLUMNNAME AS VALUE
		String ret = rhs.generateSQL( query.getSqlLogic(),ExpressionConstants.EXP_GEN_DECLARATION );
		if( rhs.getClass().getName().equals("com.sas.query.models.ColumnExpression"))
			ret = HRVParser.COLUMN_PREFIX+ret;
      return ret;
// ### DONE WITH MODIFICATIONS
   }
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
   public JspDataItem getDataItem( HRVQuery query, Expression expressionToFind, boolean findPersisted)
   {
      JspDataItem returnItem = null;    //the return value
      DataItemList itemList = query.getPersistedItemList();

      // Look thru persisted items to find this Expression. If there is a
      // match on the expression, return the result item here.  But only if
      // it's either actively a part of the query or findPersisted is set to
      // true.
//System.out.println("Matching expression: " + expressionToFind + " (" + expressionToFind.generateSQL(query.getSqlLogic(), Expression.EXP_GEN_DECLARATION) + ")");
      for (int i=0; i < itemList.size(); i++) {
         //get the current DataItem and its expression
         JspDataItem item = (JspDataItem)itemList.elementAt(i);
     Expression expression = item.getSafeExpression();
//System.out.println("  vs: " + expression + " (" + expression.generateSQL(query.getSqlLogic(), Expression.EXP_GEN_DECLARATION) + ")");

     //check the expression and our return criteria
     if ( expression.equivalentTo(query, expressionToFind )) {
        returnItem = item;
        break;                  //no need to continue
     }
      }

      return returnItem;        //return what you got
   }

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
   public int getPositionForDataItem(HRVQuery query, String item, JspDataItem jspItem)
   {
     // System.out.println("##item "+item);
     // System.out.println("##item length"+item.length());
     // System.out.println("##jspItem "+jspItem);


      int retval = -1;
      DataItemList dataItems = query.getPersistedItemList();
      String jspItemTable = "";
      Expression tempExpression1 = jspItem.getSafeExpression();
      if (tempExpression1 instanceof ColumnExpression) {
      	    Column column = ((ColumnExpression)tempExpression1).getColumn();
      	    com.sas.query.models.Table table = column.getParent();
      	    jspItemTable = table.getDisplayName();
      }

      String dataItemTable = "";
      for (retval=0; retval<dataItems.size(); retval++) {
         DataItem ditem = dataItems.elementAt(retval);
         String value = ditem.toString();

         Expression tempExpression = ditem.getExpression();
	 if (tempExpression instanceof ColumnExpression) {
	    Column column = ((ColumnExpression)tempExpression).getColumn();
	    com.sas.query.models.Table table = column.getParent();
	    dataItemTable = table.getDisplayName();

	 }

         //check against the freaking table. Not some stupid number!

         //take off 1 only if not in persisted list
         if(value.substring(value.length() -1).equals("1")){
         	boolean cutIt = true;
         	List tempItemList = new ArrayList();
         	for(int i=0; i < dataItems.size(); i++){
         	    DataItem tempItem = dataItems.elementAt(i);
         	    tempItemList.add(tempItem.toString());
         	    if(tempItem.toString().equals(value))
         		cutIt = false;
         	}

         	String itemTempString = value.substring(0, value.length()-1);
         	if(tempItemList.contains(itemTempString)){
         		//we have an alias. Is it the current item
         		if(itemTempString.equals(item))
         		    cutIt = true;
         	}


         	if(cutIt){
         		value = value.substring(0, value.length()-1);
         		isAlias = true;
         	}
         }

         int dotIndex = item.indexOf(".");
         if(dotIndex != -1)
         	item = item.substring(dotIndex + 1);
         if (value.equals(item) && jspItemTable.equals(dataItemTable)){
        	break;

         }
      }

      if (retval == dataItems.size()){
		 //if we are in here the column was not found
		 //this could be due to a summation being applied
		 //check to see
		 for (retval=0; retval<dataItems.size(); retval++) {
		     DataItem ditem = dataItems.elementAt(retval);
          	 String value = ditem.toString();

			 //first check. See if they just happen to be right...
			 if(item.equals(value)){
			 	//System.out.println("EQUALS1 " + retval);
			 	return retval;
			 }

			 //now mod value
			 String subValue = value.substring(3);
			 if(item.equals(subValue)){
			 	//System.out.println("EQUALS2 " + retval);
			 	return retval;
			 }

			 //now mod item
			 String subItem = item.substring(3);
			 if(subItem.equals(value)){
			 	//System.out.println("EQUALS3 " + retval);
			 	return retval;
			 }


		 }
         return -1;         //failed to find result item
	 }

      return retval;
   }

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
   public Expression wrapWithPut(Expression exp, Query query, String format)
   {
      if (isWrappedWithPut(exp, query))
         return exp;

      CompoundExpression putNode = null;
      UnparsedExpression fmtNode = new UnparsedExpression(format);

//      Function putFunc = query.getDataSourceFunction(Function.FUN_CAT_SPECIAL, "PUT", exp.EXP_TYPE_NUMERIC, exp.EXP_TYPE_NUMERIC, 2);
      FunctionList putFuncs = query.getDataSourceFunctions().getSubsetByName("PUT");

      Function putFunc = putFuncs.elementAt(0);

      putNode = new CompoundExpression(putFunc, exp, fmtNode);

      //System.out.println("Format = " + format+", Function:" + putFunc +", Expression:" + putNode);

      return putNode;
   }

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
   public Expression unwrapIfHasPut(Expression exp, Query query)
   {
      if (!isWrappedWithPut(exp, query))
         return exp;

      CompoundExpression tempE = (CompoundExpression)exp;
      return tempE.getParameter(0);
   }

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
   public boolean isWrappedWithPut(Expression exp, Query query)
   {
      UnparsedExpression fmtNode = null;
      CompoundExpression putNode = null;
      ColumnExpression realNode = null;

      if (!(exp instanceof CompoundExpression))
         return false;
      putNode = (CompoundExpression)exp;
      if (!"PUT".equals(putNode.getCurrentFunction().getFunctionName()))
         return false;

      if (putNode.getCurrentNumberOfOperands()<2)
         return false;

      if (!(putNode.getParameter(0) instanceof ColumnExpression && putNode.getParameter(1) instanceof UnparsedExpression))
         return false;

      realNode = (ColumnExpression)putNode.getParameter(0);
      fmtNode = (UnparsedExpression)putNode.getParameter(1);

      return true;
   }

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////




   public Expression wrapWithLeftPut(Expression exp, Query query, String format)
   {
      if (isWrappedWithLeftPut(exp, query))
         return exp;

      CompoundExpression leftNode = null;
      CompoundExpression putNode = null;
      UnparsedExpression fmtNode = new UnparsedExpression(format);

      FunctionList leftFuncs = query.getDataSourceFunctions().getSubsetByName("LEFT");
      Function leftFunc = leftFuncs.elementAt(0);

      FunctionList putFuncs = query.getDataSourceFunctions().getSubsetByName("PUT");

      Function putFunc = putFuncs.elementAt(0);

      putNode = new CompoundExpression(putFunc, exp, fmtNode);
      leftNode = new CompoundExpression(leftFunc, putNode);

      return leftNode;
   }

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
   public Expression unwrapIfHasLeftPut(Expression exp, Query query)
   {
      if (!isWrappedWithLeftPut(exp, query))
         return exp;

      CompoundExpression leftExp = (CompoundExpression)exp;
      CompoundExpression putExp = (CompoundExpression)leftExp.getParameter(0);

      return putExp.getParameter(0);
   }


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
   public boolean isWrappedWithLeftPut(Expression exp, Query query)
   {
      CompoundExpression leftNode = null;
      CompoundExpression putNode = null;
      ColumnExpression realNode = null;
      UnparsedExpression fmtNode = null;

      //exp must be a CompoundExpression
      if (!(exp instanceof CompoundExpression))
         return false;
      leftNode = (CompoundExpression)exp;
      //leftNode must have "LEFT" as the name of its function
      if (!"LEFT".equals(leftNode.getCurrentFunction().getFunctionName()))
         return false;

      //LEFT has only 1 operand
      if (leftNode.getCurrentNumberOfOperands() != 1)
         return false;

      //LEFT's operand must be a CompoundExpression
      if (!(leftNode.getParameter(0) instanceof CompoundExpression))
         return false;

      putNode = (CompoundExpression)leftNode.getParameter(0);

      if (!"PUT".equals(putNode.getCurrentFunction().getFunctionName()))
         return false;

      if (putNode.getCurrentNumberOfOperands()<2)
         return false;

      if (!(putNode.getParameter(0) instanceof ColumnExpression && putNode.getParameter(1) instanceof UnparsedExpression))
         return false;

      realNode = (ColumnExpression)putNode.getParameter(0);
      fmtNode = (UnparsedExpression)putNode.getParameter(1);

      return true;
   }


//Added by sinsat for S0267971 on 16SEP2004  - Start

//Changes made by sinsat on 21DEC2004 for S0275074 - Start
   public String getFormattedQuery(String uiColumn,String editSQL1)
   {
	  int intCounter = 100;
	  int intLineDelim = 0;
	  int intLineMerge = 0;
	  int intCommaBreak = 0;
	  String editSQL = "";
  	  StringBuffer editSQLStrBuffer = new StringBuffer();

	  //while loop is used only when filter contains complecated expression of calculated columns.
	  while(intCounter > 0){
	  	    intLineDelim = editSQL1.indexOf(", (");
	  	    intLineMerge = editSQL1.indexOf("\n",intLineDelim);
	  		intCommaBreak = editSQL1.indexOf("\n",intLineMerge+1);
			if(intLineDelim != -1 ){
		  		editSQLStrBuffer = editSQLStrBuffer.append(editSQL1.substring(0,intLineDelim+1));
		  		editSQLStrBuffer = editSQLStrBuffer.append("\n");
		  		editSQLStrBuffer = editSQLStrBuffer.append(editSQL1.substring(intLineDelim+1,intLineMerge));

				//System.out.println("1....intLineMerge --->"+intLineMerge);
		  		//System.out.println("1....intCommaBreak --->"+intCommaBreak);
		  		if(intCommaBreak - intLineMerge < 10){
					editSQLStrBuffer = editSQLStrBuffer.append((editSQL1.substring(intLineMerge+2,intCommaBreak)).trim());//changed by singab
		 			editSQLStrBuffer = editSQLStrBuffer.append((editSQL1.substring(intCommaBreak+2)).trim());//changed by singab
			 		}
	        		else{
			  		editSQLStrBuffer = editSQLStrBuffer.append((editSQL1.substring(intLineMerge+1)).trim());//changed by singab
		  		    }
		  		editSQL1 = editSQLStrBuffer.toString();

	  		}
	  		intCounter--;
	  		editSQLStrBuffer = new StringBuffer();
	  }

	  //We will consider this formatted query for parsing calculated column.
	  return editSQL1;

   }

   public String getItemFromCalculated(String uiColumn,String editSQL)
   {

   	   //Added by sinsat on 14FEB2005 for NOT operator- start
		if(uiColumn.startsWith("(NOT ")){
		     int uicolumn_pos=uiColumn.indexOf("NOT ");
		     uiColumn=uiColumn.substring(uicolumn_pos+4);
	    }
   	   //Added by sinsat on 14FEB2005 for NOT operator- end

	  //System.out.println("1....uicolumn --->"+uiColumn);
	  //System.out.println("1....editSQL --->"+editSQL);


	  //Handling for complicated expression of calculated uiColumn which includes many parenthesis.
	  int openParenCounter	= 0;
	  int closeParenCounter	= 0;
  	  for(int j = 0; j < uiColumn.length();j++){
	  		if (uiColumn.charAt(j) == '('){
	  			openParenCounter++;
	  		}
	  		if (uiColumn.charAt(j) == ')'){
	  			closeParenCounter++;
	  		}
	  }

	  if(uiColumn.startsWith("( ") && openParenCounter > closeParenCounter){
	  		uiColumn = uiColumn.substring(2);
	  }

	  //To ignore where clause in a query for this parsing - start
	  editSQL = editSQL.substring(0,editSQL.indexOf("WHERE"));//changed by singab
 	  //To ignore where clause in a query for this parsing - end
//Changes made by sinsat on 21DEC2004 for S0275074 - End

  	  int i = editSQL.indexOf(uiColumn);

  	  String part1 = editSQL.substring(i);//changed by singab
  	  //System.out.println("2....editSQL --->"+editSQL);
  	  //System.out.println("3....part1 ----> "+part1);

  	  String part2=part1.substring(part1.indexOf(uiColumn)+uiColumn.length());//changed by singab
  	  String part4=part2.substring(part2.indexOf("AS "));//Added by singab
  	  String part3 = "";
	  //System.out.println("4....part2 ----> "+part2);

//Changes made by sinsat on 20DEC2004 for S0275074 - Start
	  int commaIndx	= part4.indexOf(",");//changed by singab
	  int frmIndx = part4.indexOf("FROM ");//changed by singab
	  if (commaIndx < frmIndx && commaIndx != -1){
	  	  part3 = part4.substring((part4.indexOf("AS ")+3),(part4.indexOf(","))); //changed by singab
	  }
	  else{
	  	  part3 = part4.substring((part4.indexOf("AS ")+3),(part4.indexOf("FROM")));//changed by singab
	  }
//Changes made by sinsat on 20DEC2004 for S0275074 - End

	  part3 = part3.trim();
	  //System.out.println("5....part3 ----> "+part3);
      return part3;
   }
//Added by sinsat for S0267971 on 16SEP2004  - End

%>
<%@ include file="../Query/OperandParser.jsp" %>
