<%-- Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513 --%>
<%@ page errorPage="../Query/QueryErr.jsp" %>
<%@ page import="java.io.*,java.util.*" %>
<%@ page import="com.sas.query.*" %>
<%@ page import="com.sas.query.app.*" %>
<%@ page import="com.sas.query.datasources.*" %>
<%@ page import="com.sas.query.models.*" %>
<%@ page import="com.sas.query.models.Expression" %>
<%@ page import="com.sas.query.parser.*" %>
<%@ page import="com.sas.query.visuals.*" %>
<%@ page import="com.sas.hrv.*" %>
<%@ page import="com.sas.rmi.Connection" %>
<%@ page import="com.sas.servlet.beans.*" %>
<%@ page import="com.sas.servlet.beans.html.*" %>
<%@ page import="com.sas.collection.StringCollection" %>
<%@ include file="../Jsp/HRVLoginInclude.jsp" %>
<%@ include file="../Query/QueryInclude.jsp" %>
<%!
   static final String ASCENDING = "ASC";
   static final String DESCENDING = "DESC";

   static StringCollection sortOrderModel = new StringCollection();
   static {
      sortOrderModel.add("");
      sortOrderModel.add(ASCENDING);
      sortOrderModel.add(DESCENDING);
   }
%>    
<%

   //  2004.01.10  - adding code to allow the display of column labels on the
   //  "Format Data" page.  This will be based on the "Show Descriptive Names" 
   //  checkbox on the "Select Columns" page
   //  This option can be turned off by using the configuration option "QueryFormatDataWithLabels"
   boolean labelDisplayOption = m_query.isShowLabels();
   String configLabelDisplayOption = (String)hrvi.getConfigValue("QueryFormatDataWithLabels");
   int columnFieldSize = 20;
   if ("NO".equalsIgnoreCase(configLabelDisplayOption) || 
       "N".equalsIgnoreCase(configLabelDisplayOption)  ||
       "OFF".equalsIgnoreCase(configLabelDisplayOption)) {
          labelDisplayOption = false;
          columnFieldSize = 32;
   }
   // end of new code


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//###Getting a list of the selected columns####
DataItemList allItems = ((HRVQuery)m_query).getPersistedItemList();
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

   //This variable is for request parameter propagation
   HashMap riders = new HashMap();
   riders.put("sessionkey", m_sessionKey);
   //need to propagate several HRV parameters
   riders.put("explorerType", request.getParameter("explorerType"));
   riders.put("actualType", request.getParameter("actualType"));
   riders.put("window", request.getParameter("window"));
   riders.put("topic", request.getAttribute("topic"));

   VisMsg bundle = (VisMsg)request.getAttribute("resources");
   String m_groupItem = bundle.getString("Display.Group.txt");
   String m_aggBlankLabel = bundle.getString("Display.AggregateBlankLabel.txt");

   String action = request.getParameter("intAction");

   if (action != null) {

      String distinct_p = request.getParameter("distinct");
      if (distinct_p != null && distinct_p.trim().length() > 0) {
	 if (m_query.getDuplicateRowsRule() != Query.DR_DISTINCT)
	    m_query.setDuplicateRowsRule(Query.DR_DISTINCT);
      } else {
      	 m_query.setDuplicateRowsRule(Query.DR_DEFAULT);
      }

      //get the list of DataItems from the query
      
      
      DataItemList dataItems = allItems;
      int activeCount = dataItems.size();

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
      OrderItemList orderItems = new OrderItemList();
      Vector positionedOrderItems = new Vector(dataItems.size());
      positionedOrderItems.setSize(dataItems.size());

      DataItem item = null;		//DataItem holder
      String inResults_p = null;	//"item#.show" param
      String group_p = null;		//"item#.group" param
      String aggregate_p = null;	//"item#.aggregate" param
      String name_p = null;		//"item#.name" param
      String sortDir_p = null;		//"item#.sorting" param
      String priority_p = null;		//"item#.priority" param
      String formatted_p = null;	//"item#.formatted" param
      String formattedvalues = "";	//String containing formatted sort items

      for (int i=0; i<dataItems.size(); i++) {
      	 item = dataItems.elementAt(i);
      	 //###These are the value of selected items on the UI###
      	 inResults_p = request.getParameter("item" + i + ".show");
      	 group_p = request.getParameter("item" + i + ".group");
      	 aggregate_p = request.getParameter("item" + i + ".aggregate");
      	 name_p = request.getParameter("item" + i + ".alias");
      	 sortDir_p = request.getParameter("item" + i + ".sorting");
	 priority_p = request.getParameter("item" + i + ".priority");
	 formatted_p = request.getParameter("item" + i + ".formatted");
	 
	if(formatted_p != null && formatted_p.trim().length() > 0){
		formattedvalues = formattedvalues + item.toString() + "^^" + item.getFormat() + "*";
	}
	

////////////////////////////////////////////////////////////////////////////////
// Check the visible/hidden (result item) field
////////////////////////////////////////////////////////////////////////////////
	 
	 //###Just determine whether or not to add to results
	 // if inResults_p != null then include in results
	 if (inResults_p != null && inResults_p.trim().length() > 0) {
	    ((JspDataItem)item).result( );

//BKD:NOTE - not sure if this still holds true!  seems to, though.
//	    int desiredPosition = dataItems.getIthPositionForResultItem( item.getResultItem() );
	    int desiredPosition = m_query.getIthPositionForResultItem( dataItems, item.getResultItem() );
	    int actualPosition = m_query.getPositionForResultItem( item.getResultItem() );
	    if ( actualPosition != desiredPosition ) {
		    m_query.moveResultItem( actualPosition, desiredPosition );
	    }
	 } else {
	    ((JspDataItem)item).deleteResultItem( );
	 }

////////////////////////////////////////////////////////////////////////////////
// Check the name/alias field
////////////////////////////////////////////////////////////////////////////////
	 // if name_p is non-trivial, then check if update needed
	 if (name_p != null && name_p.trim().length() > 0) {
	    if (!name_p.equals(item.getDisplayString())) {
	       item.setAlias(m_dataSource.getValidSASName(name_p));	//set alias?
	    }
	 }

////////////////////////////////////////////////////////////////////////////////
// Check the grouping field
////////////////////////////////////////////////////////////////////////////////
	 if (group_p != null && group_p.trim().length() > 0) {
	    item.group();		//group flag is set
	 } else {
	    //if we don't have the "group" then delete the GroupItem
	    item.deleteGroupItem();	//group flag is not set
	 }

////////////////////////////////////////////////////////////////////////////////
// Check the aggregate field
////////////////////////////////////////////////////////////////////////////////
	 // if aggregate_p is non-trivial, then set function or grouping
	 if (aggregate_p != null) {
	    aggregate_p = aggregate_p.trim();
	 }

	 boolean isFunc = false;	//flag to see if function applied
	 if (aggregate_p != null && aggregate_p.length() > 0) {
	    Function function = null;
	    
	    //### Gets the function list for the item if aggregate is checked ###
	    //### Then gets a list of valid functions for that item and validates ###
	    FunctionList functionList = m_query.getFunctionListForDataItem( m_query, item );

	    //search list for match on function name
	    for (int j=0; j<functionList.size(); j++) {
	       String funcName = functionList.elementAt(j).getName();
	       if (funcName.equals(aggregate_p)) {
		  function = functionList.elementAt(j);
		  if (function != item.getAggregation())
		     item.setAggregation( function );
		  isFunc = true;
		  break;
	       }
	    }
	 }

	 //if not a function, then delete the aggregation
	 if (!isFunc) {
	    if (item.isAggregation())
	       item.deleteAggregation();
	 }

	 // Remove old format/informat if they are of the wrong type
	 boolean bFormatCorrect = item.getExpression().isFormatOfCorrectType(
					   item.getFormat(),
					   ExpressionConstants.EXP_TYPE_UNKNOWN
				       );
	 boolean bInformatCorrect = item.getExpression().isFormatOfCorrectType(
					   item.getInformat(),
					   ExpressionConstants.EXP_TYPE_UNKNOWN
				       );
	 if (!bFormatCorrect) {
	    item.setFormat(null);
	 }
	 if (!bInformatCorrect)
	    item.setInformat(null);

////////////////////////////////////////////////////////////////////////////////
// Check the sorting field
////////////////////////////////////////////////////////////////////////////////
      	 int sortDirVal = DataItem.OC_MISSING;
	 int sortPriVal = DataItem.OC_MISSING;

	//### Set the sort direction ###
	 // if sortDir_p is non-trivial, then set sort direction
	 if (sortDir_p != null) {
	    sortDir_p = sortDir_p.trim();
	    if (ASCENDING.equalsIgnoreCase(sortDir_p)) {
	       sortDirVal = OrderItem.OC_ASC;
	    } else if (DESCENDING.equalsIgnoreCase(sortDir_p)) {
	       sortDirVal = OrderItem.OC_DESC;
	    }
	 }

	//### Set the sort priority ###
	 // if priority_p is non-trivial then set sort priority
	 if (priority_p != null) {
	    try {
	       int priority = Integer.parseInt(priority_p);
	       if (priority > -1) {
		  sortPriVal = priority;
	       }
	    } catch (NumberFormatException nfe) {
	       //not a valid number - what now?
	    }
	 }

	 if (sortDirVal == DataItem.OC_MISSING && sortPriVal == DataItem.OC_MISSING) {
	    item.deleteOrderItem();
	 } else {
	    if (item.getOrderItem() == null || item.getOrderItem().getSortingDirection() != sortDirVal)
	       item.order( sortDirVal, DataItem.OC_MISSING);

	    if (sortPriVal != DataItem.OC_MISSING) {
//application.log("Adding positioned order item: " + item.getOrderItem() + ", at pos=" + sortPriVal);
	       if (positionedOrderItems.elementAt(sortPriVal) == null) {
		  positionedOrderItems.setElementAt(item.getOrderItem(), sortPriVal);
	       } else {
		  positionedOrderItems.insertElementAt(item.getOrderItem(), sortPriVal);
	       }
	    } else  {
//application.log("Adding unpositioned order item: " + item.getOrderItem());
	       orderItems.addElement(item.getOrderItem());
	    }
	 }

	//### Will need to check to see if we want to sort by format value or actual value ###


	 //If we are sorting or grouping, then ensure an alias exists if needed.
	 //?? item.setAlias( item.generateUniqueAlias() );

	 //Ensure that a display name will exist for this result item
	 ResultItem ri = item.getResultItem();
	 if (ri != null && ri.getDisplayName() == null) {
	    String newName = ((HRVDataSource)m_dataSource).getNewDisplayName(ri);
	    
	    //### May have to do something here to sort by format or actual ###
	    ri.setAlias(m_query.getUniqueResultName(((HRVDataSource)m_dataSource).getValidSASName(newName)));
	 }
      }//###End of Loop ###
      
      
      //##### Need to write the formatted values on the table bean #####
      if(formattedvalues != null && formattedvalues.trim().length() > 0){
      	 TableBean m_tempTableBean = m_query.getWorkingTableBean();
      	 m_tempTableBean.setAttributeValue("formattedsort", formattedvalues);
      	 m_tempTableBean.write();
      }
      

      //### Uses the OrderItem class to keep the order by clause in a specified order ###
      int orderCount = 0;
      for (int i=0; i<positionedOrderItems.size(); i++) {
      	 OrderItem oItem = (OrderItem)positionedOrderItems.elementAt(i);
	 if (oItem != null) {
	    if (i > orderItems.size()) {
//application.log("Appending positioned item: " + oItem.getExpression());
	       orderItems.addElement(oItem);
	    } else {
//application.log("Inserting positioned item: " + oItem.getExpression() + ", at pos=" + i);
	       orderItems.insertElementAt(oItem, i);
	    }
	    orderCount++;
	 }
      }

      for (int i=0; i<orderItems.size(); i++) {
      	 OrderItem oItem = orderItems.elementAt(i);
	 int actualPosition = m_query.getPositionForOrderItem(oItem);
	 int desiredPosition = i;

//application.log("moving item("+oItem.getExpression()+") from " + actualPosition + " to "+desiredPosition);
	 if ( actualPosition != desiredPosition ) {
	    m_query.moveOrderItem( actualPosition, desiredPosition );
	 }
      }
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
      firePropertyChanges(m_query);
   }
   
   
   	
 //########### This code get the formatted sort values off either the temp or original table bean ###########
         TableBean m_tempTableBean = m_query.getWorkingTableBean();
         String formatsorts = m_tempTableBean.getAttributeValue("formattedsort");
         
         //if no attribute yet exists, get it off the original table bean
         if(formatsorts == null){
              TableBean o_tempTableBean = m_query.getOriginalTableBean();
              if(o_tempTableBean != null)
              	formatsorts = o_tempTableBean.getAttributeValue("formattedsort");
         }
         
         if(formatsorts == null)
         	formatsorts = "";
         	
         HashMap formatMap = new HashMap();
         StringTokenizer st = new StringTokenizer(formatsorts, "*");
         while(st.hasMoreTokens()){
         	String token = st.nextToken();
         	String item = token.substring(0, token.indexOf("^^"));
         	String format = token.substring(token.indexOf("^^") + 2);
   		formatMap.put(item, format);
   	
   	 }
         
//##############################################################################################################
   
	
//###Set the order and group by on the temp where###
	
	HashMap filterMap = (HashMap)session.getAttribute(m_tempTableBean.getMetaKey());
	
	String groupBy = m_query.getGroupByString();
	String orderBy = m_query.getOrderByString();
	String tempWhere = (String)filterMap.get("_snapshot");
	
	if(tempWhere == null)
		tempWhere = "";
	String tempOrderAndGroup = "";
	//clear any old order or group bys
	if(tempWhere.indexOf("ORDER BY") != -1)
		tempWhere = tempWhere.substring(0, tempWhere.indexOf("ORDER BY"));

	if(tempWhere.indexOf("GROUP BY") != -1)
		tempWhere = tempWhere.substring(0, tempWhere.indexOf("GROUP BY"));

	if(groupBy != null && !groupBy.equals("")){
		tempOrderAndGroup = tempOrderAndGroup + " GROUP BY " + groupBy;
	}
	if(orderBy != null && !orderBy.equals("")){
		//check here to see if the sort is by format or value
		//Example: order by put(date, worddate.), put(x,4.);
		tempOrderAndGroup = tempOrderAndGroup + " ORDER BY " + orderBy;
		Iterator i = formatMap.keySet().iterator();
		while(i.hasNext()){
			String key = (String)i.next();
			if(tempOrderAndGroup.indexOf(key) != -1){
				//parse up this string to be correct for sorting on format
				String format = (String)formatMap.get(key);
				String front = tempOrderAndGroup.substring(0, tempOrderAndGroup.indexOf(key));
				String back = tempOrderAndGroup.substring(tempOrderAndGroup.indexOf(key) + key.length());
				String insert = "put(" + key + ", " + format + ")";
				tempOrderAndGroup = front + insert + back;
			}
		}
	}

	tempOrderAndGroup = tempOrderAndGroup.trim();
	
	

	
	filterMap.put("orderandgroup", tempOrderAndGroup);
	filterMap.put("_snapshot", tempWhere + tempOrderAndGroup);
	
	session.setAttribute(m_tempTableBean.getMetaKey(), filterMap);
	

//### Done adding the group and order by ###


   //Get next step to go to (if any)
   String stepToGoto = null;
   if (action != null) {
      if (action.startsWith("goto.")) {
      	 stepToGoto = action.substring(5);
      } else if (action.startsWith("showProps.")) {
      	 request.setAttribute("propertiesItem", action.substring(10));
	 riders.put("item", action.substring(10));
	 riders.put("returnTo", "display");
	 stepToGoto = "dataitm";
      }
   }

   // Quick check to see if we can display or not based on # of items in
   // persisted items list
   if (m_query.getPersistedItemList().size() == 0) {
      stepToGoto = "selcols";
      riders.put("msg", "NoneSelected.txt");
   }


   //process page navigation
   if (stepToGoto != null) {
      if ("editsql".equals(stepToGoto)) {
	 riders.put("returnTo", request.getAttribute("topic"));
      }

      //If we are moving to the 'edit sql' step, then we need to set the
      // returnTo parameter so it will send us back to the right place.
      String nextURL = getRedirectURL(bundle, stepToGoto, riders);

      //send URL redirect to browser and stop processing
      response.sendRedirect(response.encodeRedirectURL(nextURL));
      return;
   }

////////////////////////////////////////////////////////////////////////////////
// we're not moving to another page, so let us setup the view for this one
////////////////////////////////////////////////////////////////////////////////
   Checkbox distinctRowsCheckbox = new Checkbox();
      distinctRowsCheckbox.setName("distinct");
      distinctRowsCheckbox.setLabel(bundle.getString("Display.DistinctInputLabel.txt"));
      distinctRowsCheckbox.setSelected( (m_query.getDuplicateRowsRule() == Query.DR_DISTINCT));
   request.setAttribute("form.distinct", distinctRowsCheckbox);

   //First, gather the data items
   DataItemList dil = allItems;
   request.setAttribute("dataItems", dil);	//save it for later

   //Now, setup the various data for the TransformationBeans
   String m_inResultsBoxLabel = bundle.getString("Display.InResultsInputLabel.txt");
   String m_groupBoxLabel = bundle.getString("Display.GroupInputLabel.txt");
   
   //TODO:Change this label
   String m_formatBoxLabel = bundle.getString("Display.GroupInputLabel.txt");

   //setup the sort order description model
   StringCollection sortOrderDescription = new StringCollection();
   sortOrderDescription.add(bundle.getString("Display.SortOrderBlankLabel.txt"));
   sortOrderDescription.add(bundle.getString("Display.Ascending.txt"));
   sortOrderDescription.add(bundle.getString("Display.Descending.txt"));

   //setup the sort priority names model
   StringCollection priorityNames = new StringCollection();
   priorityNames.add(bundle.getString("Common.First.txt"));
   priorityNames.add(bundle.getString("Common.Second.txt"));
   priorityNames.add(bundle.getString("Common.Third.txt"));
   priorityNames.add(bundle.getString("Common.Fourth.txt"));
   priorityNames.add(bundle.getString("Common.Fifth.txt"));
   priorityNames.add(bundle.getString("Common.Sixth.txt"));
   priorityNames.add(bundle.getString("Common.Seventh.txt"));
   priorityNames.add(bundle.getString("Common.Eight.txt"));
   priorityNames.add(bundle.getString("Common.Ninth.txt"));
   priorityNames.add(bundle.getString("Common.Tenth.txt"));
   priorityNames.add(bundle.getString("Common.Eleventh.txt"));
   priorityNames.add(bundle.getString("Common.Twelfth.txt"));
   priorityNames.add(bundle.getString("Common.Thirteenth.txt"));
   priorityNames.add(bundle.getString("Common.Fourteenth.txt"));
   priorityNames.add(bundle.getString("Common.Fifteenth.txt"));
   priorityNames.add(bundle.getString("Common.Sixteenth.txt"));

   StringCollection priorityNameModel = new StringCollection();
   StringCollection priorityNameDescModel = new StringCollection();
   priorityNameModel.add("-1");
   priorityNameDescModel.add(bundle.getString("Display.SortPriorityBlankLabel.txt"));
   for (int i=0; i<dil.size(); i++) {
      priorityNameModel.add(String.valueOf(i));
      if (i<priorityNames.count())
      	 priorityNameDescModel.add(priorityNames.get(i));
      else
      	 priorityNameDescModel.add(String.valueOf(i));
   }

   boolean doGroupingJS = true;
   if (m_query.getGroupItemCount() > 0)
      doGroupingJS = false;	//a grouping has already occurred

	int statPixels = ReportBuilder.calculateStatMinPixels(session);

	

   for (int i=0; i<dil.size(); i++) {
      DataItem item = dil.elementAt(i);
      //setup the aggregate model
      StringCollection aggModel = new StringCollection();
      StringCollection aggDescModel = new StringCollection();
      aggModel.add("");
      aggDescModel.add(m_aggBlankLabel);
      FunctionList functionList = getFunctionListForDataItem( m_query, item, bundle );
      for (int j=0; j<functionList.size(); j++) {
      	 aggModel.add(functionList.elementAt(j).getFunctionName());
      	 aggDescModel.add(bundle.getString("Display.FunctionDesc." + functionList.elementAt(j).getFunctionName() + ".txt"));
      }

      Checkbox inResultsBox = new Checkbox();
      	 inResultsBox.setName("item"+i+".show");
	 inResultsBox.setLabel(m_inResultsBoxLabel);
      Checkbox groupBox = new Checkbox();
      	 groupBox.setName("item"+i+".group");
	 groupBox.setLabel(m_groupBoxLabel);
	 if (doGroupingJS)
	    groupBox.setCustomAttributes("OnClick=\"OnClickGroup("+i+")\"");

      Choicebox functionChoice = new Choicebox();
      	 functionChoice.setName("item"+i+".aggregate");
	 functionChoice.setModelInterface(aggModel);
	 functionChoice.setDescriptionModel(aggDescModel);
	 functionChoice.setCustomAttributes(" STYLE=\"width:"+statPixels+"px\"");
      TextEntry aliasText = new TextEntry();
      	 aliasText.setName("item"+i+".alias");
	 aliasText.setMaximumLength(200);
	 
         //  2004.01.10  - change the column field size related to whether column labels are being shown
         aliasText.setSize(columnFieldSize);
	 
      Choicebox orderChoice = new Choicebox();
      	 orderChoice.setName("item"+i+".sorting");
	 orderChoice.setModelInterface(sortOrderModel);
	 orderChoice.setDescriptionModel(sortOrderDescription);
	 orderChoice.setCustomAttributes("OnChange=\"OnChangeSortDir("+i+")\"");
      Choicebox priorityChoice = new Choicebox();
      	 priorityChoice.setName("item"+i+".priority");
	 priorityChoice.setModelInterface(priorityNameModel);
	 priorityChoice.setDescriptionModel(priorityNameDescModel);
	 priorityChoice.setCustomAttributes("OnChange=\"OnChangeSortPriority("+i+")\"");
	 
      Checkbox formattedValueBox = new Checkbox();
         formattedValueBox.setName("item"+i+".formatted");
	 formattedValueBox.setLabel(m_formatBoxLabel);
	 //formattedValueBox.setSelected(true);

      boolean isInResults = ((JspDataItem)item).isInResults();
      String aggValue = "";
      if (item.getExpression().isAggregation() == true) {
      	 aggValue = item.getAggregation().getFunctionName();
      }
      
      
      //#################################################### Needs to happen down below #####
      if(formatMap.containsKey((String)item.toString())){
      	formattedValueBox.setSelected(true);
      }
      
      request.setAttribute(formattedValueBox.getName(), formattedValueBox);
      

      String sortDir = "";
      OrderItem orderItem = item.getOrderItem();
      if (orderItem != null) {
      	 switch (orderItem.getSortingDirection()) {
	    case OrderItem.OC_DEFAULT:
	    case OrderItem.OC_ASC:
	       sortDir = ASCENDING;
	       break;
	    case OrderItem.OC_DESC:
	       sortDir = DESCENDING;
	       break;
	 }
      }

      Integer priorityIndex = null;
      if (orderItem != null)
	 priorityIndex = new Integer(m_query.getPositionForOrderItem(orderItem) + 1);

      fillInValue(request, inResultsBox, null, null);
      fillInValue(request, groupBox, null, null);
      fillInValue(request, functionChoice, aggModel, aggValue);
      fillInValue(request, aliasText, null, item.getDisplayString());
      fillInValue(request, orderChoice, sortOrderModel, sortDir);
      fillInValue(request, priorityChoice, priorityNameModel, priorityIndex);

      if (action == null) {
      	 inResultsBox.setSelected(isInResults);
	 groupBox.setSelected(item.getGroupItem() != null);
      }
   }

   pageContext.forward((String)request.getAttribute("viewURL"));
%>
<%!
public void fillInValue(HttpServletRequest request, BaseTransformation bean, StringCollection model, Object defval)
      throws java.io.IOException
{
   String name = bean.getName();
   String value = request.getParameter(name);

   if (bean instanceof BaseInput) {
      if (defval != null)
      	 ((BaseInput)bean).setText(defval.toString());
      if (value != null)
	 ((BaseInput)bean).setText(value);
   } else if (bean instanceof Choicebox) {
      if (defval != null) {
      	 if (defval instanceof Integer) {
	    ((Choicebox)bean).setSelectedIndex(((Integer)defval).intValue());
	 } else {
	    ((Choicebox)bean).setSelectedItem(defval.toString());
	 }
      }
      if (value != null && model.contains(value))
      	 ((Choicebox)bean).setSelectedIndex(model.getIndex(value, 0));
   } else if (bean instanceof Listbox) {
      String [] vals = request.getParameterValues(name);
      StringCollection values = new StringCollection(vals);
      if (values.count() > 0 ) 
	     ((Listbox)bean).setSelectedItems(values);
   } else if (bean instanceof Checkbox) {
      ((Checkbox)bean).setSelected( (value != null) );
   }

//application.log("Adding bean to request: " + name);
   request.setAttribute(name, bean);
}
%>
