<%-- Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513 --%>
<%@ page errorPage="../Query/QueryErr.jsp" %>
<%@ page import="java.io.*,java.util.*" %>
<%@ page import="com.sas.query.*" %>
<%@ page import="com.sas.query.app.*" %>
<%@ page import="com.sas.query.datasources.*" %>
<%@ page import="com.sas.query.models.*" %>
<%@ page import="com.sas.query.models.Expression" %>
<%@ page import="com.sas.query.parser.*" %>
<%@ page import="com.sas.query.visuals.*" %>
<%@ page import="com.sas.hrv.*" %>
<%@ page import="com.sas.rmi.Connection" %>
<%@ page import="com.sas.collection.StringCollection" %>
<%@ page import="com.sas.servlet.beans.html.*" %>
<%@ include file="../Jsp/HRVLoginInclude.jsp" %>
<%@ include file="../Query/QueryFunctions.jsp" %>
<%!
   /**
    * The session attribute name string for datasource used by all query
    * objects.
    */
   static final String DATASOURCE_KEY = "query.datasource";
   /**
    * The session attribute name string for loading/saving the query between
    * page accesses.
    */
   static final String QUERY_KEY = "hrvQuery.query";
   /**
    * The session attribute name string for loading/saving the most recently
    * accessed query object between page accesses.
    */
   static final String LAST_QUERY_OBJ = "hrvQuery.last.query";

   public static int USAGE_ALL = 0;
   public static int USAGE_WHERE = 1;
%>
<%
   /**
    * The query object we are persisting across page accesses.
    */
   HRVQuery m_query = null;
   /**
    * The datasource object we are persisting across page accesses.
    */
   HRVDataSource m_dataSource = null;
   /**
    * The message handler we are persisting across page accesses.
    */
   MessageHandler m_messages = null;

   String m_sessionKey = null;

   int m_usageMode = USAGE_ALL;

   Object m_queryControl = null;

   // At this point, the user should already be logged in to HRVision.

   /* Setting up session-persistant variables */
   Object __query_temp_obj = null;  //Temp object for session attribs

   //Check for stored datasource
   __query_temp_obj = hrvi.getSessionValue(session, DATASOURCE_KEY);
   if (__query_temp_obj == null || !(__query_temp_obj instanceof DataSource)) {
      // Create a JQuery MessageHandler to pass to the HRVDataSource constructor
      m_messages = new MessageHandler();
      // Now we can instantiate the HRVDataSource object.
      m_dataSource = new HRVDataSource(session, m_messages);
      // BKD: I'm setting the name here for looks but it's not necessary
      m_dataSource.setName("HRVision");
      m_dataSource.refresh();
      // Store the datasource for future use
      hrvi.setSessionValue( session, DATASOURCE_KEY, m_dataSource );
   } else {
      m_dataSource = (HRVDataSource)__query_temp_obj;
      //re-read the database
//      m_dataSource._initialize();
      m_dataSource.refresh();
   }
   //grab a ref to the MessageHandler class
   m_messages = m_dataSource.getMessageHandler();

   TableBean m_origTableBean = null;
   TableBean m_tempTableBean = null;

   m_sessionKey = request.getParameter("sessionkey");
if (m_sessionKey == null) {
   m_query = new HRVQuery(m_dataSource, m_messages);
////////////////////////////////////////////////////////////////////////////////
// Get the key/location pair from HRVision
   String m_key = request.getParameter("key");
   String m_properKey = request.getParameter("properKey");
   String m_location = request.getParameter("location");

   HashMap filterMap = new HashMap();
   filterMap.put("_snapshot", "");
   filterMap.put("orderandgroup", "");

   boolean m_fromProps = ("y".equalsIgnoreCase(request.getParameter("fromProps")));
   int m_locationInt = -1;

   try {
      m_locationInt = Integer.parseInt(m_location);
   } catch (NumberFormatException nfe) {
      //this is real bad... w/o a valid location, where do we stick the data?
      m_locationInt = -1;
   }

   //There are 3 ways to start query
   ////////////////////////////////////////////////////////////
   //  1) New Query
   //   key = null
   //   properKey = null
   //   fromProps = null
   //  2) Edit from Explorer
   //   key = [key of existing object]
   //   properKey = null
   //   fromProps = null
   //  3) Edit from Property Sheet
   //   key = [key of temporary object]
   //   properKey = [key of existing object]
   //   fromProps = 'Y'
   ////////////////////////////////////////////////////////////

   if (m_key == null || m_key.trim().length() == 0) {
//application.log("Generating new Query");
      //this is a new query
      m_tempTableBean = new TableBean(session);
      m_tempTableBean.setTemp(true);
      m_tempTableBean.setMetaLocation(m_locationInt);
      m_tempTableBean.setMetaKey(m_tempTableBean.getNewMetaKey());
//application.log("Working TableBean: key="+m_tempTableBean.getMetaKey() + ", loc=" + m_tempTableBean.getMetaLocation());
   } else {
      //this is a query from an existing table
//application.log("Editing existing Query - " + m_key);
      if (m_fromProps) {
//application.log(m_key + ": Edit request came from properties...");
     m_origTableBean = new TableBean(session);
     m_origTableBean.setMetaLocation(m_locationInt);
     m_origTableBean.setMetaKey(m_properKey);

     m_tempTableBean = new TableBean(session);
     m_tempTableBean.setTemp(true);
     m_tempTableBean.setMetaLocation(m_locationInt);
     m_tempTableBean.setMetaKey(m_key);
      } else {
//application.log(m_key + ": Edit request came from explorer...");
     m_origTableBean = new TableBean(session);
     m_origTableBean.setMetaLocation(m_locationInt);
     m_origTableBean.setMetaKey(m_key);

     m_tempTableBean = new TableBean(session);
     m_tempTableBean.setTemp(true);
     m_tempTableBean.setMetaLocation(m_locationInt);
     m_tempTableBean.setMetaKey(m_origTableBean.copyItemToTemp(m_locationInt));
      }
   }

   ((HRVQuery)m_query).setOriginalTableBean(m_origTableBean);
   ((HRVQuery)m_query).setWorkingTableBean(m_tempTableBean);

   if (m_origTableBean != null) {
//application.log("Checking for query source in existing bean...");
//      String oldSQL = m_origTableBean.getAttributeValue("querysrc");
      String oldSQL = m_tempTableBean.getAttributeValue("querysrc");
      if (oldSQL != null) {
     m_messages.removeAllMessages();
     // have to check for tables now with the new lazy init...
     // Tokenize the string
     Tokenizer tokenizer = new Tokenizer2( m_dataSource, oldSQL, m_messages );
     TokenList tokenList = tokenizer.getTokens();
     java.util.List list = Tokenizer2.getNeededTables(tokenList, m_query, m_dataSource);
    for (int i = 0; i < list.size(); i++)
    {
        String tableKey = (String)list.get(i);
        HRVDataSourceContainer container;
        int ourLocation;
        if (MetaBean.PUBLIC_DATA_LIBREF.equalsIgnoreCase(tableKey.substring(0, tableKey.indexOf("."))))
        {
            ourLocation = MetaBean.PUBLIC_LOC;
           container = (HRVDataSourceContainer)m_dataSource.getItems().elementAt(0);
        }
        else
        {
            ourLocation = MetaBean.PRIVATE_LOC;
           container = (HRVDataSourceContainer)m_dataSource.getItems().elementAt(1);
        }
        HRVDataSourceTable dst =
            new HRVDataSourceTable(session, container, tableKey.substring(tableKey.indexOf(".")+1), ourLocation);
        com.sas.query.models.Table table = new com.sas.query.models.Table (m_query, dst);
        m_query.addTable(table);
        container.getItems(true).addElement(dst);
    }
    // end of new code

//application.log("Setting query SQL to existing query SQL: " + oldSQL);
     m_query.setSQL(oldSQL + "  "); //BKD:NOTE - weird bug where query
                    //  doesn't recognize the last token
                    //  unless there is whitespace at the
                    //  end of the SQL...

	//String snapshot =  m_query.getOriginialWhere();
	//SQL CORRECT AT THIS POINT
	String groupBy = m_query.getGroupByString();
	String orderBy = m_query.getOrderByString();
	String tempOrderAndGroup = "";
	if(groupBy != null && !groupBy.equals("")){
		tempOrderAndGroup = tempOrderAndGroup + " GROUP BY " + groupBy;
	}
	if(orderBy != null && !orderBy.equals("")){
		tempOrderAndGroup = tempOrderAndGroup + " ORDER BY " + orderBy;
	}

	String tableSql = m_origTableBean.getAttributeValue("querysrc");

	if(tableSql.indexOf("WHERE") != -1)
		tableSql = tableSql.substring(tableSql.indexOf("WHERE") + 5);
	else
		tableSql = "";


	tempOrderAndGroup = tempOrderAndGroup.trim();

	//#### 5/7/04 maperr ########

	filterMap.put("_snapshot", tableSql);
	filterMap.put("orderandgroup", tempOrderAndGroup);



        //###########################

     //BKD:NOTE - should error check for invalid SQL or unparsed tables or
     //other miscellaneous problems...
      } else {
     //TableBean doesn't have query source!  Need to tell the user!
     //But what next?
      }
   }

   m_sessionKey = "que." + m_tempTableBean.getMetaKey();
   hrvi.setSessionValue( session, m_sessionKey, m_query );
   hrvi.setSessionValue( session, m_sessionKey + ".fromProps", new Boolean(m_fromProps));

   session.setAttribute(m_tempTableBean.getMetaKey(), filterMap);


	//need to check the status of the complex query
	//complex_query
	String complex_query = m_tempTableBean.getAttributeValue("complex_query");
	System.out.println("complex : " + complex_query);
	if(complex_query != null && complex_query.equals("on"))
		session.setAttribute("complex_filter_on", "on");
	else
		session.setAttribute("complex_filter_on", "");
}

   //Check for our persistant Query object
   m_queryControl = hrvi.getSessionValue(session, m_sessionKey);
   if (m_queryControl instanceof WhereClauseBuilder) {
      WhereClauseBuilder wcb = (WhereClauseBuilder)m_queryControl;
      m_query = wcb.getQuery();
      m_usageMode = USAGE_WHERE;
      //this is not at all supposed to happen here
   } else if (m_queryControl instanceof Query) {
      m_query = (com.sas.query.HRVQuery)m_queryControl;
      m_usageMode = USAGE_ALL;
   } else {
      //error state!
   }

   //save that object in a special "last object referenced" spot - just might
   //be useful someday...
   hrvi.setSessionValue( session, LAST_QUERY_OBJ, m_queryControl );

////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

%>
<%
//////////////////////////////////////////////////////////////////////
// Parameters from HRVision:
//  explorerType    - usually 'tables'
//  window      - usually 'MainHRVWindow'
//  key     -
//  topic       -
//  saveString  - usually 'NEWSAVE'
//  location    - usually '2' sometimes '1'
//  actualType  - usually 'Query' maybe 'table'
//////////////////////////////////////////////////////////////////////

   //Get the resource bundle for JspQuery
   VisMsg bundle = VisMsg.getInstance(session, "com.sas.query.JSPQuery");
   request.setAttribute("resources", bundle);

   //SETUP the important URLs
   request.setAttribute("topic", "selcols");

   //SETUP the initial flag value
   request.setAttribute("showButtons", Boolean.FALSE);

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

   Hashtable globals = ((HRVQuery)m_query).getHrvParameters();
   if (globals == null) {
      globals = new Hashtable();
      ((HRVQuery)m_query).setHrvParameters(globals);
   }

   Hashtable myParameters = new Hashtable();
   myParameters.put("sessionkey", m_sessionKey);

   Hashtable qParms = HttpUtils.parsePostData(request.getContentLength(), request.getInputStream());
   if (qParms == null)
      qParms = new Hashtable();

   if (request.getQueryString() != null) {
      qParms.putAll(HttpUtils.parseQueryString(request.getQueryString()));
   }

   if (qParms.size() > 0) {
//////////////////////////////////////////////////
      String[] moveToGlobals = {
     "key",
     "location",
     "topic",
     "type",
     "saveString",
     "actualType",
     "window",
     "explorerType"
      };
      String[] params = null;
      boolean modified = false;

      for (int i=0; i<moveToGlobals.length; i++) {
     params = (String[])qParms.get(moveToGlobals[i]);
     if (params != null) {
        globals.remove(moveToGlobals[i]);
        globals.put(moveToGlobals[i], params);
        qParms.remove(moveToGlobals[i]);
        modified = true;
     }
      }
      myParameters.putAll(qParms);

// commenting out because there is no reason we should need to redirect through here a second
// time -- jch
//      if (modified) {
//         response.sendRedirect(response.encodeRedirectURL(request.getRequestURI() + "?" + buildParameterString(myParameters)));
//         String tmpurl = request.getRequestURI() + "?" + buildParameterString(myParameters);
//         forwardURL(tmpurl, out, request, response);
//     return;
//      }
   }

	//2/16/2006 MAPERR -  clear user prompt vector
	session.removeAttribute("userPromptVector");

   //SEND the request to the logic for processing
   response.sendRedirect(response.encodeRedirectURL("../Query/Step1.jsp?" + buildParameterString(myParameters)));
%>
